import Bladex
import Enm_Def
import AuxFuncs
import CharStats
import GenFX
import whrandom
import Actions
import Reference
import GameStateAux
import AniSound
import Combat
import BCopy
import Basic_Funcs
import Damage
import ItemTypes
import InitDataField
import B3DLib
import Auras
import math
import Blood
import EnemyTypes
import Interpolator
import ObjStore
import dust
import Sparks

TRUE = 1==1
FALSE = not TRUE




def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
		
def RemoveMyCorpse(PersonName, dx, dz):
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(me.Name,))
	
	
	
def RemoveMyWeapon(WeaponName):
	wp = Bladex.GetEntity(WeaponName)
	if wp:
		wp.Alpha=1.00
		wp.RasterMode="Read"
		wp.CastShadows=0
		AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))
		
		
		
		

def SkelDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	
	if AttackerName:
		att=Bladex.GetEntity(AttackerName)
		if att.Person:
			if att.Kind=="Skeleton":
				print "I have been hit by a buddy but I don't care"
				return
	else:
		print VictimName+" has no Attacker?"
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)
	
	
	
def DarkKnightDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	
	if WeaponName:
		wp=Bladex.GetEntity(WeaponName)
		if wp.Kind[0:6]=="Flecha":
			print VictimName+" :I have been hit by an arrow but I don't care"
			return
	
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)

	
###########################################################################################################################################################
#### Base Enemy Class


class EnemyChar (Enm_Def.NPCPerson):

	DeathFunc=None
	DeathArgs=()
	Dusted=0
	KilledEnemyFunc=None
	
	
	
	
	def __init__(self, me):
		Enm_Def.NPCPerson.__init__(self, me)
		
		self.Dusted=0
		me.ImDeadFunc=self.NewImDeadFunc
		self.DeathFunc=None
		self.DeathArgs=(me.Name,)
		self.KilledEnemyFunc=None
		
		
	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me = Bladex.GetEntity(EntityName)
		
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
				

	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				# consider getting furious
				chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)
					
			
			
	def OnKilledEnemy(self,KilledEntityName):
		Basic_Funcs.PlayerPerson.OnKilledEnemy(self,KilledEntityName)
		if self.KilledEnemyFunc:
			apply(self.KilledEnemyFunc)
		
		
						
	
	def __getstate__(self):	
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["EnemyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
						 GameStateAux.SaveFunctionAux(self.KilledEnemyFunc),
		                                 self.DeathArgs,
		                                 self.Dusted)
		                                 
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["EnemyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			GameStateAux.LoadFunctionAux(parms[1],self,"KilledEnemyFunc")
			self.DeathArgs=parms[2]
			self.Dusted=parms[3]
			
		me=Bladex.GetEntity(self.Name)
		me.ImDeadFunc=self.NewImDeadFunc
		
		
##########################################################################################################################################################
######## Race Sub-Classes


class SlimeySkeleton (EnemyChar):
	def __init__(self, me):
				
		EnemyChar.__init__(self, me)

		self.Dusted=1
		me.DamageFunc=SkelDamage
		me.MeshName = "DarkSkel"
		me.SelfIlum=0.4
		
		

	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosEsqueleto(EntityName)


	def NewImDeadFunc (self,EntityName):
		print EntityName+" :I am dead again"
		me = Bladex.GetEntity(EntityName)
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
		print EntityName+" ready for dusting"
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoPerson,(EntityName,100,0,))
		
		inv=me.GetInventory()
		lwp=Bladex.GetEntity(me.InvLeft)
		rwp=Bladex.GetEntity(me.InvRight)
		if lwp:
			Reference.EntitiesSelectionData[lwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+10,RemoveMyWeapon,(lwp.Name,))
			print lwp.Name+" ready for dusting"
		if rwp:
			Reference.EntitiesSelectionData[rwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+11,RemoveMyWeapon,(rwp.Name,))
			print rwp.Name+" ready for dusting"
		
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(Combat.SkeletonAttackData)



			
			
		

class ConquestSkeleton (EnemyChar):
	def __init__(self, me):
				
		EnemyChar.__init__(self, me)

		self.SoundPriorities[Reference.SND_ARROW]   =  1.0
		self.SoundPriorities[Reference.SND_HIT]     =  1.0
		self.SoundPriorities[Reference.SND_NPC]     = -1.0
		self.SoundPriorities[Reference.SND_NOISYPC] =  3.0
		self.SoundPriorities[Reference.SND_PC]      =  2.0
		
		
		

	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosEsqueleto(EntityName)



	
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)		
		if(NPCPerson_state[0]!=1):
			print "ERROR: Skeleton.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["ConquestSkeleton"]=()
		return NPCPerson_state
		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["ConquestSkeleton"]
			

	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(Combat.SkeletonAttackData)

	def NewImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		print "El esqueleto se convertira en polvo"
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoPerson,(EntityName,100,0,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		inv=me.GetInventory()
		lwp=Bladex.GetEntity(me.InvLeft)
		rwp=Bladex.GetEntity(me.InvRight)
		if lwp:
			Reference.EntitiesSelectionData[lwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+16,RemoveMyWeapon,(lwp.Name,))
		if rwp:
			Reference.EntitiesSelectionData[rwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+17,RemoveMyWeapon,(rwp.Name,))
		
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		
		
		
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+12, dust.EnPolvoObjeto,(obj_name,100,0,))


	def StdDelayNoSeen(self,EntityName):
		pass

############################################################################################################################################################

class ConquestMinotaur (EnemyChar):
	def __init__(self, me):
		# base class init
		EnemyChar.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.33
		self.DamageFactorHeavy = 0.5
		
		
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosMinotaur(EntityName)

	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(Combat.MinotaurAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0



#########################################################################################################################################################



class ConquestOrk (EnemyChar):
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		if me.Kind=="Ork":
			me.MeshName="Dark_Ork"
		
		
		
		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Ork":
			AniSound.AsignarSonidosOrco(EntityName)
		else:
			AniSound.AsignarSonidosOrcoGrande(EntityName)
		
		


	def ResetCombat (self,EntityName):
		EnemyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Combat.OrkAttackData)
			self.ChanceOfFuryOnHurt = 0.45	
			
			
##########################################################################################################################################################




class MyBolaDalGurak(ItemTypes.BolaDalGurak):
	
	def __init__(self, me, ownerName):
		ItemTypes.BolaDalGurak.__init__(self, me, ownerName)



	def PrevOnHitFunc (self, EntityName, hit_entity):
		# Called on the impact of the ball with the world, or an Entity (if Damage parameter==1)
		print EntityName+" hitting "+hit_entity
		if not hit_entity:
			self.OnHitFunc(EntityName, hit_entity)
		else:
			thing=Bladex.GetEntity(hit_entity)
			if thing:
				if thing.Name=="MiddleColumn":
					print "Hit Column"
					self.HitColumnFunc(EntityName, hit_entity)



	def HitColumnFunc(self, EntityName, hit_entity):
		print "Could Zap Dal Here"
		self.OnHitFunc(EntityName, hit_entity)
		if self.OwnerName:
			owner= Bladex.GetEntity(self.OwnerName)
			print "Zapping Dal"
			tx,ty,tz=owner.Position
			x,y,z=231500,44500,-60000
			bolt=Bladex.CreateEntity(self.Name+"_Bolt", "Entity ElectricBolt", x,y,z)
			bolt.Target=tx,ty,tz
			bolt.MaxAmplitude=120
			bolt.MinSectorLength=10000
			bolt.Damage=1
			bolt.Active=1
			bolt.CoreGlowColor=50.0, 200.0, 50.0
			bolt.InnerGlowColor=10.0, 100.0, 10.0
			bolt.OuterGlowColor=0.0, 0.0, 0.0
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,self.KillBolt,(bolt,))
			


	def KillBolt(self,bolt):
		bolt.SubscribeToList("Pin")
		







def MyMakeDalBall (name, x,y,z, ownerName=""):
	missile= Bladex.CreateEntity(name, "Entity Magic Missile", x, y, z)
	missile.Data= MyBolaDalGurak (missile, ownerName)
	return missile





class ConquestDal (EnemyTypes.DalGurak):
	def __init__(self, me):
		
		EnemyTypes.DalGurak.__init__(self, me)
		

	def StartBall (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			xl,yl,zl= me.GraspPos("L_Hand")
			xr,yr,zr= me.GraspPos("R_Hand")
			vx,vy,vz= me.Rel2AbsVector(0,-800.0,0.0)
			x,y,z= (xl+xr)*0.5+vx, (yl+yr)*0.5+vy, (zl+zr)*0.5+vz
			self.AGE_Number=self.AGE_Number+1
			ball= MyMakeDalBall(EntityName+"_DalBall"+`self.AGE_Number`, x,y,z, EntityName)
			self.BallName= ball.Name
		




	
			
##########################################################################################################################################################

class ConquestKnight_Traitor (EnemyChar):
	def __init__(self, me):
		
		EnemyChar.__init__(self, me)
		

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		me.ImDeadFunc=self.NewImDeadFunc
		me.DamageFunc=DarkKnightDamage
		
		
	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me = Bladex.GetEntity(EntityName)
		
		inv=me.GetInventory()
		
		
		lwp=Bladex.GetEntity(me.InvLeft)
		rwp=Bladex.GetEntity(me.InvRight)
		if lwp:
			Reference.EntitiesSelectionData[lwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+16,RemoveMyWeapon,(lwp.Name,))
		if rwp:
			Reference.EntitiesSelectionData[rwp.Name]=()
			Bladex.AddScheduledFunc(Bladex.GetTime()+17,RemoveMyWeapon,(rwp.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+10,RemoveMyCorpse,(EntityName,100,0,))
			
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
	
	
	
	
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+8.0, RemoveMyWeapon,(obj_name,))
	
	
	
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Knight_Traitor":
			AniSound.AsignarSonidosCaballeroTraidor(EntityName)
		elif me.Kind=="Dark_Knight":
			AniSound.AsignarSonidosCaballeroOscuro(EntityName)


	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Combat.TraitorKnightAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00




##############################################################################################################################################################



class ConquestTroll (EnemyChar):
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0



	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosTroll(EntityName)
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			me.BlockingPropensity = 0.8
			me.AttackList = BCopy.deepcopy(Combat.TrollAttackData)


################################################################################################################################################################



class ConquestGolem (EnemyChar):

	AGE= 0
	StoneType="Piedra_Glm_st"
	StoneGrowTime= 0.8
	ScaleVar= 0.0
	AlphaVar= 0.0
	StoneAlpha=1.0
	StoneSelfIlum=0.0


	def __init__(self, me):
		
		EnemyChar.__init__(self, me)

		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.25

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		
		me.AddAnmEventFunc("StoneAppears", self.StoneAppearsHandler)
		
		me.ImDeadFunc=self.ImDeadFunc
		
		
		self.NoFXOnHit= TRUE

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosGolem_st(EntityName)
		




	def __getstate__(self):
		
		NPCPerson_state=EnemyChar.__getstate__(self)
		me=Bladex.GetEntity(self.Name)

		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1][me.Kind]=(self.AGE,
						self.StoneType,
						self.StoneGrowTime,
						self.ScaleVar,
						self.AlphaVar,
						self.StoneAlpha,
						self.StoneSelfIlum)

		return NPCPerson_state
		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)

		version=parm[0]
		if version==1:
			parms=parm[1][me.Kind]
			self.AGE=parms[0]
			self.StoneType=parms[1]
			self.StoneGrowTime=parms[2]
			self.ScaleVar= parms[3]
			self.AlphaVar= parms[4]
			self.StoneAlpha= parms[5]
			self.StoneSelfIlum= parms[6]
		
		me.AddAnmEventFunc("StoneAppears", self.StoneAppearsHandler)			
		self.NoFXOnHit= TRUE




	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.2, self.Destroza,(EntityName,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
	
	
	
	
	
	
	def Destroza(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.SeverLimb(1)
		me.SeverLimb(2)
		me.SeverLimb(4)
		me.SeverLimb(6)
		me.SeverLimb(8)
		me.CastShadows = 0
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(Combat.StoneGolemAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0


	def ScaleStone (self, obj_name, time):
		obj= Bladex.GetEntity(obj_name)
		parent= obj.Parent
		if parent:
			me = Bladex.GetEntity(parent)
			me.Unlink(obj)
		obj.Scale= obj.Scale+self.ScaleVar
		if obj.Scale>=1.0:
			obj.Scale= 1.0
			obj.RemoveFromList("Timer60")
			obj.TimerFunc=""
		if parent:
			me.GetInventory().LinkLeftHand(obj.Name)
	
	
	def DownScaleStone (self, obj_name, time):
		obj= Bladex.GetEntity(obj_name)
		parent= obj.Parent
		if parent:
			me = Bladex.GetEntity(parent)
			if me and me.Person and me.InvLeft==obj_name:
				inv= me.GetInventory()
				inv.LinkLeftHand(NULL)
			me.Unlink(obj)
			
			
		obj.Scale= max (0,0, obj.Scale-self.ScaleVar)
		obj.Alpha= max (0,0, obj.Alpha-self.AlphaVar)
		if obj.Scale<=0.0 or obj.Alpha<=0.0:
			obj.RemoveFromList("Timer60")
			obj.TimerFunc=""
			obj.RemoveFromWorld()
			obj.SubscribeToList("Pin")
	
	
	def StoneStopFunc (self, EntityName):
		print "stopping stone ",EntityName
		stone= Bladex.GetEntity(EntityName)
		if stone:
			stone.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			stone.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			stone.Alpha=self.StoneAlpha
			stone.TimerFunc= self.DownScaleStone
			stone.SubscribeToList("Timer60")
				
				
	def StoneAppearsHandler (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if not me.InvLeft:
			self.AGE= self.AGE+1
			x,y,z= me.GraspPos("L_Hand")
			stone= Bladex.CreateEntity(EntityName+"_"+self.StoneType+"_"+`self.AGE`, self.StoneType, x,y,z, "Weapon")
			stone.Mass= 5
			init_scale= 0.25
			stone.Alpha=self.StoneAlpha
			stone.Scale= init_scale
			stone.SelfIlum= self.StoneSelfIlum
			
			self.ScaleVar= (1.0-init_scale)/(60.0*self.StoneGrowTime)
			self.AlphaVar= self.ScaleVar
			stone.TimerFunc= self.ScaleStone
			stone.SubscribeToList("Timer60")
			stone.OnStopFunc= self.StoneStopFunc
			
			me.GetInventory().LinkLeftHand(stone.Name)
			me.Data.ThrowForce= 2.0
			stone.ExcludeHitFor(me)
		me.AddAnmEventFunc("ThrowLeftEvent",self.ThrowReleaseEventHandler)


	def ThrowReleaseEventHandler(self, EntityName, EventName):
		me = Bladex.GetEntity(EntityName)
		Actions.ThrowReleaseEventHandler(EntityName, EventName)
		if me.InvLeft:
			object = Bladex.GetEntity(me.InvLeft)
			object.TimerFunc=""
			object.SubscribeToList("Pin")
			inv=me.GetInventory()
			inv.LinkLeftHand("None")




def GolemDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	print VictimName+" : ooooow!!!"
	me=Bladex.GetEntity(VictimName)
	if WeaponName:
		wp=Bladex.GetEntity(WeaponName)
		
		print VictimName+" I have been hit by "+WeaponName
		if DamageNode==2 and wp.Kind in ("Flecha","FlechaEnvenenada","FlechaFuego"):
			print "Head hit"
			print "I have been hit in the head with an arrow"
			if me.Life>0.0:
				me.Life=0
				char=Bladex.GetEntity("Player1")
				char.Data.OnKilledEnemy(VictimName)
			return
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)






class AcidGolem (ConquestGolem):

	luz=None
	LuzIntensMax=7.0
	ActPos=0,0,0
	
	def __init__(self, me):
		ConquestGolem.__init__(self, me)
		self.StoneType="Piedra_Glm_lv"
		self.StoneSelfIlum=1.0
		
		
		me.MeshName="Golem_lava"
		self.StoneAlpha=0.6
		self.StoneSelfIlum=0.8
		self.luzIntensMax=7.0
		self.ActPos=0,0,0
		self.luz = Bladex.CreateEntity(self.Name+"Luz","Entity Spot",0,0,0)
		self.luz.Color       = 100,200,0
		self.luz.Intensity   = 0
		self.luz.Precission  = 0.303456
		self.luz.CastShadows = 0
		self.luz.Visible     = 1
		self.luz.SizeFactor  = 0
		me.Link(self.luz)
		
		Bladex.CreateTimer("Timer8",1.0/8.0)
		self.LuzIntensMax=7.0
		
		me.ImDeadFunc=self.ImDeadFunc
		me.DamageFunc=GolemDamage
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosGolem_st(EntityName)
		Bladex.ReadBitMap("../../Maps/NewConquest/AcidGolemIcon.bmp","AcidGolemIcon")
		Reference.EnemiesScorerData[self.Name]=("AcidGolemIcon","Glm")	
		
		
	def Hide(self):
		me=Bladex.GetEntity(self.Name)
		me.Alpha= 0.0
		me.CastShadows=0
		me.Freeze()
	
		
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.2, self.Destroza,(EntityName,))
		self.LightDown()
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		# burn away?
		
		
	def Deploy(self):
		me=Bladex.GetEntity(self.Name)
		me.UnFreeze()
		x,y,z=me.Position
		me.Blind=1
		me.Deaf=1
		self.LightUp()
		me.Alpha= 0.6
		me.SelfIlum= 0.8
		me.CastShadows=0
		me.CatchOnFire(x,y,z)
		me.Wuea = Reference.WUEA_ENDED
		me.SetTmpAnmFlags(1,1,1,0,5,1,0)
		me.LaunchAnmType("awake")
		me.Position=self.ActPos[0],self.ActPos[1],self.ActPos[2]
		me.AnmEndedFunc=self.Activate(self.Name)
	
	
	def Activate(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.Blind=0
		me.Deaf=0
		me.AnmEndedFunc=None
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.25, me.SetOnFloor,() )
	
	
	
	def LightUp (self):				
		self.luz.TimerFunc= self.IncreaseLightIntensity
		self.luz.SubscribeToList("Timer8")
		
	
			
	def IncreaseLightIntensity(self, ent_name, time):
		if self.luz.Intensity>self.LuzIntensMax:	
			self.luz.RemoveFromList("Timer8")
			self.luz.TimerFunc=""
			print "Golem Light full"
		else:
			self.luz.Intensity=self.luz.Intensity+0.3


	def LightDown (self):		
		self.luz.TimerFunc= self.DecreaseLightIntensity
		self.luz.SubscribeToList("Timer8")



	def DecreaseLightIntensity(self, ent_name, time):		
		if self.luz.Intensity>0.10:
			self.luz.Intensity=self.luz.Intensity-0.05
		else:
			self.luz.RemoveFromList("Timer8")
			self.luz.TimerFunc=""
		
		
		
		
		
	def __getstate__(self):	
		NPCPerson_state=ConquestGolem.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		
		Luz_Name=""		
		if self.luz:
			Luz_Name=self.luz.Name
		NPCPerson_state[1]["AcidGolem"]=(Luz_Name,self.ActPos)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		ConquestGolem.__setstate__(self,parm)
		Luz_Name=""
		me=Bladex.GetEntity(self.Name)
		version=parm[0]
		if version==1:
			parms=parm[1]["AcidGolem"]
			Luz_Name= parms[0]
			self.ActPos=parms[1]
			self.luz=Bladex.GetEntity(Luz_Name)
			Bladex.CreateTimer("Timer8",1.0/8.0)
			me.Alpha= 0.85
			me.SelfIlum= 0.8
		me.ImDeadFunc=self.ImDeadFunc
		
		
#####################################################################################################################################################################################################

sndcrunch=Bladex.CreateSound("..\\..\\Sounds\\aplastamiento.wav", "CrunchSound")
sndcrunch.Volume=1.0
sndcrunch.MinDistance=10000
sndcrunch.MaxDistance=30000

def BurnAway(EntityName):
	ps=Bladex.CreateEntity(EntityName+"Burning", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=EntityName
	ps.ParticleType="DeathCloud"
	ps.Time2Live=64
	ps.RandomVelocity=0
	ps.Velocity=0,-200,0
	ps.NormalVelocity=2.0
	ps.YGravity=-300
	ps.DeathTime=Bladex.GetTime()+1.5
	ps.PPS=600   
	me = Bladex.GetEntity(EntityName)
	me.Alpha=0.8
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(EntityName, 0.8, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.RemoveFromWorld,())
	sndpos=Bladex.GetEntity(EntityName).Position
	sndcrunch.Play(sndpos[0],sndpos[1],sndpos[2])
	
	
def BurnAway2(ObjName):
		me= Bladex.GetEntity(ObjName)
		if me:
			wps=Bladex.CreateEntity(ObjName+"WPS", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
			wps.ObjectName=ObjName
			wps.ParticleType="DeathCloud"
			wps.Time2Live=64
			wps.RandomVelocity=0
			wps.Velocity=0,-150,0
			wps.NormalVelocity=2.0
			wps.YGravity=-300
			wps.DeathTime=Bladex.GetTime()+1.5
			wps.PPS=300
			me = Bladex.GetEntity(ObjName)
			me.Alpha=1.00
			me.RasterMode="Read"
			me.CastShadows=0
			AuxFuncs.FadeObject(ObjName, 1.00, 0.0, 4.0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.RemoveFromWorld,())
			


class ConquestSalamander (EnemyChar):
	
	AGE_Number=0
	aura=None
	active=0

	def __init__(self, me):
		
		EnemyChar.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		
		
		
		pos= me.Position	
		self.aura=Bladex.CreateEntity(me.Name+"_Aura","Entity Aura",pos[0],pos[1],pos[2])
		self.aura.SetAuraParams(40, 1, 1, 0, 0, 1)
		self.aura.SetAuraGradient(2, 0.8, 0.6, 0.0, 0.6, 0.0, 0.8, 0.1, 0.0, 0.0, 0.6)
		
		me.Link(self.aura)
		self.aura.SetAuraActive(0)

		self.active=0

		me.AddAnmEventFunc("Spit", self.StartSpit)

		me.ImDeadFunc=self.SalImDeadFunc
		me.MutilateFunc=self.NewMutilateFunc
	
	
	
	

	
	
	def __getstate__(self):	
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["ConquestSalamander"]=(self.AGE_Number, self.active)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["ConquestSalamander"]
			self.AGE_Number=parms[0]
			self.active=parms[1]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		me=Bladex.GetEntity(self.Name)
		self.aura=Bladex.GetEntity(me.Name+"_Aura")
		self.aura.SetAuraGradient(2, 0.8, 0.6, 0.0, 0.6, 0.0, 0.8, 0.1, 0.0, 0.0, 0.6)
		self.aura.SetAuraActive(0)




	def RedGlow(self,EntityName):
		self.aura.SetAuraActive(1)
		self.active=1


	def NewMutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		Blood.Mutilate (EntityName,obj_name,x,y,z,nx,ny,nz,node)
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7, BurnAway2,(obj_name,))


	def SalImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		self.StopGlow(EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+9, BurnAway,(EntityName,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
		
	def StopGlow(self,EntityName):
		self.aura=Bladex.GetEntity(EntityName+"_Aura")
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+11,self.StopGlow2,(EntityName,))
		print"sal extinuished"
		
		
	def StopGlow2(self,EntityName):
		self.aura.SetAuraActive(0)

		
	


	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosSalamander(EntityName)


	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(Combat.SalamanderAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0


	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Salamander":
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,   1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +6.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						Damage.DropInvalidObjectsOnImpact (victim.Name)
						victim.Wuea=Reference.WUEA_ENDED
						if victim.InCombat: 
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else: 
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def SpitFunc(self, fireball_name,end_time,period):
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period))
				
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if me.InCombat: 
			SQDistance= me.SQDistance2(Bladex.GetEntity(me.GetEnemyName()))
			max_firefan_dist= 4000.0
			
			# Get an angle to the target
			target= Bladex.GetEntity(me.GetEnemyName())
			target_pos= target.Position
			x,y,z= me.GraspPos("ViewPoint")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			
			if  SQDistance < (max_firefan_dist*max_firefan_dist):
				# fan out spit
				duration= 0.3
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/10.0
				fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="Flame"
				fireball.Time2Live=20
				fireball.YGravity=-4900.0
				fireball.Friction=0.12
				fireball.PPS=512
				fireball.DeathTime=end_time;
				F= 5400.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=55.0
				self.SpitFunc(fireball.Name, end_time, period)
			else:
				# fireball spit
				nparticles= 70
				duration= 2.0/60.0 # I think this is a minimum
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/7.0
				fireball=Bladex.CreateEntity(EntityName+"_Fireball_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="LargeFire"
				fireball.Time2Live=30
				fireball.YGravity=-400.0
				fireball.Friction=0.075
				fireball.PPS=nparticles/duration
				fireball.DeathTime=end_time;
				F= 25000.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=15.0
				self.SpitFunc(fireball.Name, end_time, period)



#####################################################################################################################################################################################################


def CKDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	
	if AttackerName:
		att=Bladex.GetEntity(AttackerName)
		if att.Person:
			if att.Name != "Player1":
				print "I have been hit by a buddy but I don't care"
				return
	else:
		print VictimName+" has no Attacker?"
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)




class ConquestChaosKnight (EnemyTypes.ChaosKnight):

	Deathfunc=None
	Deathargs=()
	RangeAttack=0
	

	def __init__(self, me):
		EnemyTypes.ChaosKnight.__init__(self, me)
		
		self.RWeapon=""
		self.LWeapon=""
		self.RangeAttack=0
		me.ImDeadFunc=self.ImDeadFunc
		me.DamageFunc=CKDamage
		me.OnStepFunc = None
		self.Deathargs=(me.Name,)
		self.dissappsound1=Bladex.CreateSound("..\\..\\Sounds\\M-RUMBLE-ROCA.wav", "DissappSound1")
		self.dissappsound1.Volume=1.0
		self.dissappsound1.MinDistance=10000
		self.dissappsound1.MaxDistance=20000
		self.dissappsound2=Bladex.CreateSound("..\\..\\Sounds\\M-IMPACTO-FUEGO.wav", "DissappSound2")
		self.dissappsound2.Volume=0.6
		self.dissappsound2.MinDistance=10000
		self.dissappsound2.MaxDistance=20000
	
	
	
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(ConquestChaosKnightAttackData)
			
			
	
	def ImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		x,y,z=me.Position
		self.dissappsound1.Play(x, y, z, 0)
		#darfuncs.Temblores(1.5,50)
		DeathCloud=Bladex.CreateEntity("DeathCloud-" + me.Name, "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		DeathCloud.PersonName		= me.Name
		DeathCloud.ParticleType		= "DeathCloud"
		DeathCloud.Time2Live		= 64
		DeathCloud.RandomVelocity	= 5
		DeathCloud.Velocity		= 0,0,0
		DeathCloud.NormalVelocity	= 3.0
		DeathCloud.YGravity		= -100
		DeathCloud.FollowFactor		= 0.5
		DeathCloud.DeathTime		= Bladex.GetTime() + 7.5
		DeathCloud.PPS			= 400
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.0,self.dissappsound2.Play,(x, y, z, 0,))
		me.Alpha=1.0
		me.RasterMode="Read"
		me.CastShadows=0
		AuxFuncs.FadeObject(me.Name, 1.00, 0.0, 9.0)
		if self.RWeapon:
			rwp=Bladex.GetEntity(self.RWeapon)
			rwp.RasterMode="Read"
			rwp.CastShadows=0
			AuxFuncs.FadeObject(self.RWeapon, 1.00, 0.0, 9.0)
			print "Fading CK Sword"
		if self.LWeapon:
			lwp=Bladex.GetEntity(self.RWeapon)
			lwp.RasterMode="Read"
			lwp.CastShadows=0
			AuxFuncs.FadeObject(self.LWeapon, 1.00, 0.0, 9.0)
			print "Fading CK Shield"
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+15.0,DumpMe,(EntityName,))
		
		
		ListaDeNodos=("Head", "L_Shoulder", "L_Elbow", "L_Hand", "R_Shoulder", "R_Elbow", "R_Hand", "Center", "L_Knee", "L_Foot", "R_Knee", "R_Foot")
		GenFX.ElectricDischarge(me.Name, "ElectricBolt-" + me.Name, 10, 40, 200, 600, ListaDeNodos, 8, 7)
		if self.Deathfunc:
			apply(self.Deathfunc,self.Deathargs)
			
		# Destroy Weapons...Disabled- probs with savegame

		#Bladex.AddScheduledFunc(Bladex.GetTime()+10,self.DestroyWeapons,(EntityName,))  #### ?????
		
		

	def DestroyWeapons(self,EntityName):
		print"start destroy weapons"
		if self.RWeapon != "":
			Bladex.AddScheduledFunc(Bladex.GetTime()+4, self.DestroySword,(self.RWeapon,))
		if self.LWeapon != "":
			Bladex.AddScheduledFunc(Bladex.GetTime()+5, self.DestroyShield,(self.LWeapon,))
		
		
	def DestroySword(self,Sword):
		flash1 = Bladex.CreateEntity("SwordFlash1", "Entity Particle System Dobj", 0,0,0)
		flash1.ObjectName=Sword
		flash1.ParticleType   = "EnergyConc"
		flash1.YGravity       = 0 
		flash1.Friction       = 0
		flash1.PPS            = 400
		flash1.Velocity       = 0,0,0 
		flash1.Time2Live      = 60 
		flash1.RandomVelocity = -5
		flash1.NormalVelocity = -8.0
		flash1.DeathTime=Bladex.GetTime()+3.0
		AuxFuncs.FadeObject(Sword,1.0,0.0,4)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,self.DumpIt,(Sword,))
		print"Sword vanishing"
		
	def DestroyShield(self,Shield):
		if not Shield:
			print "Chaos Knight has no shield"
			return
		flash2 = Bladex.CreateEntity("ShieldFlash1", "Entity Particle System Dobj", 0,0,0)
		flash2.ObjectName=Shield
		flash2.ParticleType   = "EnergyConc"
		flash2.YGravity       = 0 
		flash2.Friction       = 0
		flash2.PPS            = 400
		flash2.Velocity       = 0,0,0 
		flash2.Time2Live      = 60 
		flash2.RandomVelocity = -5
		flash2.NormalVelocity = -8.0
		flash2.DeathTime=Bladex.GetTime()+3.0
		AuxFuncs.FadeObject(Shield,1.0,0.0,4)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,self.DumpIt,(Shield,))
		print"Shield vanishing"


	def DumpIt(self,Thing):
		obj=Bladex.GetEntity(Thing)
		obj.Position=0,20000,0
		
		
		
		
	def EndRangeAttack(self):
		self.RangeAttack=0
		
		
		
		
		
	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
		Reference.debugprint(EntityName + ": Can't reach the git")
		if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP:
			return
			
		# see if range attack possible
		if not self.RangeAttack:
			print "Not Range attack"
			if me.GetEnemyName():
				print "I have enemy"
				en=Bladex.GetEntity(me.GetEnemyName())
				if me.CanISee(en):
					print "I CAN see enemy"
					if not Actions.IsFacingEntity(EntityName, en.Name):
						Actions.TurnToFaceEntity(EntityName,en.Name)
					me.LaunchAnmType("g_magic")
					self.RangeAttack=1
					Bladex.AddScheduledFunc(Bladex.GetTime()+8, self.EndRangeAttack,())
					return
			else:
				print "I have no enemy"
		if me.InsideActionArea(me.ActionAreaMin) and (check1aaTo2aa and not me.Will1aaTo2aa):

			if me.Data.goto_limit2aa:
				back_area_min=me.ActionAreaMin
				back_area_max=me.ActionAreaMax
				me.ActionAreaMin=0
				me.ActionAreaMax=0
				enemy=Bladex.GetEntity(me.GetEnemyName())
				des_pos=enemy.Position
				me.GoToJogging=1
				if me.GoTo(des_pos[0],des_pos[1],des_pos[2]):
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
				else: 
					Reference.debugprint(EntityName + ": GoTo enemy_pos not working, with action area 0!")
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max


			return

		elif me.InsideActionArea(me.ActionAreaMin):
			if me.GetActionMode() != Enm_Def.ROUTE_WATCH:
				self.LaunchMyWatch (EntityName)
			if not Actions.IsFacingEntity(EntityName, me.GetEnemyName()):
				Actions.TurnToFaceEntity(EntityName, me.GetEnemyName())
			else:
				curr_time=Bladex.GetTime()
				if curr_time-self.last_insulting_time_1AA>4:
					insult_prob=whrandom.uniform(0.0, 1.0)
					if insult_prob<0.8:
						Combat.Insult(EntityName)
					insult_var=whrandom.uniform(-2.0, 1.0)
					self.last_insulting_time_1AA=Bladex.GetTime()+insult_var
		else:
			back_area_min=me.ActionAreaMin
			back_area_max=me.ActionAreaMax
			me.ActionAreaMax= 0
			me.ActionAreaMin= 0
			
			init_pos=me.InitPos
			me.InvertedRoute=1 # Move backwards
			if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
			else:
				Reference.debugprint(EntityName + ": GoTo init_pos not working, with action area 0!")
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
				
				
				
					
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=EnemyTypes.ChaosKnight.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		me=Bladex.GetEntity(self.Name)
		NPCPerson_state[1]["ConquestChaosKnight"]=(GameStateAux.SaveFunctionAux(self.Deathfunc),
		                                       self.Deathargs,
		                                       self.RWeapon,
		                                       self.LWeapon,
		                                       self.dissappsound1,
		                                       self.dissappsound2,
		                                       self.RangeAttack)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		EnemyTypes.ChaosKnight.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["ConquestChaosKnight"]
			GameStateAux.LoadFunctionAux(parms[0],self,"Deathfunc")
			self.Deathargs=parms[1]
			self.RWeapon=parms[2]
			self.LWeapon=parms[3]
			self.dissappsound1=parms[4]
			self.dissappsound1=parms[5]
			self.RangeAttack=parms[6]
			
			
			
ConquestChaosKnightAttackData =	[ 
           # inner zone blocks:
            [Combat.BLOCK,  0.85, (),                   500.0, 1000.0, 3000.0, 0.35],
			         
           # attacks:
            #[Combat.ATTACK, 0.02, ("SP1",),            7000.0, 9000.0,50000.0, 0.35],
            [Combat.ATTACK, 0.20, ("G01",),            1490.0, 2195.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.15, ("G02",),            1410.0, 2105.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.10, ("G07",),            1550.0, 2225.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.10, ("G08",),            1700.0, 2375.0, 3050.0, 0.35],
            [Combat.ATTACK, 0.07, ("G12",),            1850.0, 2525.0, 3200.0, 0.35],
            [Combat.ATTACK, 0.07, ("G18",),            3050.0, 3600.0, 3850.0, 0.35],
            [Combat.ATTACK, 0.05, ("G31",),            2450.0, 3600.0, 3850.0, 0.35],
]
			
		
		
##################################################################################################################################################################################################


Bladex.AddParticleGType("GasVenenoso3","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	if i>40:
		aux=((60.0-i)/20.0)**0.3
	else:
		aux=(i/40.0)**0.5
	r=10
	g=150
	b=180 
	a=255.0*aux
	size=400.0+800.0*aux
	Bladex.SetParticleGVal("GasVenenoso3",i,r,g,b,a,size)
		


def BreakVampShield(EntityName):
	print "Break vamp shield: "+EntityName
	me=Bladex.GetEntity(EntityName)
	if me.InvLeft<>"":
		
		esc=Bladex.GetEntity(me.InvLeft)
		if esc:
			Damage.DropInvalidObjectsOnImpact (EntityName)
			me.Wuea=Reference.WUEA_ENDED
			me.LaunchAnmType("df_s_broken")
			inv=me.GetInventory()
			inv.RemoveShield(me.InvLeft)
			inv.LinkLeftHand("None")
			esc.Impulse(0,0,0)
			if me.Data.NPC:
				me.Data.ResetCombat (EntityName)
		




class ConquestVampShield:
	def __init__(self, me):
		me.Weapon=1
		self.Name= me.Name
		self.Rebound= 0.8
		

	def AbsorbFunc (self, AttackerName, WeaponName, DamagePoints):
		attacker= Bladex.GetEntity(AttackerName)
		me=Bladex.GetEntity(self.Name)
		if attacker and attacker.Person:
			effective_damage= max(DamagePoints*self.Rebound, 0.0)
			if attacker.Kind=="Golem_stone":
				if attacker.Life>0:
					LastDamage= min (effective_damage, attacker.Life)
					attacker.Life= attacker.Life-LastDamage
					attacker.Wuea=Reference.WUEA_ENDED
					attacker.InterruptCombat()
					attacker.LaunchAnmType("hurt_f_big")
					
					
					
					
					#DamageZone=Reference.BODY_FRONT
					#DamageType="Drain"
					#attacker.Data.RespondToHit(AttackerName, self.Name, LastDamage, DamageType, DamageZone, 0)
					return
				
				
			
			if WeaponName:
				print self.Name+" :being hit by "+WeaponName
				wp = Bladex.GetEntity(WeaponName)
				owner=""
				if me.Parent:
					owner=Bladex.GetEntity(me.Parent)
					print self.Name+" :I am carried by "+owner.Name
				if not owner:
					print self.Name+" :I have on owner"
					return
				
				print "check weapon state"
				if wp.Data.Destructor:
					print "Weapon IS enabled"
					BreakVampShield(owner.Name)
					print "Smash my shield"
				else:
					print "weapon not enabled"
			
			
			special= ['Drain']
			special_resistance= attacker.Data.GetResistance(special[0])
			
			#if Damage.SpecialDamageFuncs.has_key(special[0]):
			#	special_damage_func= Damage.SpecialDamageFuncs[special[0]]
			#	special_damage_func (special, special_resistance, effective_damage, AttackerName, None, self.Name, special[0], Reference.BODY_FRONT, 0, 0, 0, 0, 0)
			
			LastDamage= min (effective_damage, attacker.Life)*(1.0-special_resistance)
			
			#if LastDamage>0 and not attacker.Data.Invincibility:
			#	attacker.Life= attacker.Life-LastDamage
			
			DamageZone=Reference.BODY_FRONT
			DamageType="Drain"
			attacker.Data.RespondToHit(AttackerName, self.Name, LastDamage, DamageType, DamageZone, 0)	
			
		
		
		
class ConquestVamp (EnemyChar):


	Fader= None
	FadeOutTime= 0.45
	FadeInTime= 0.65
	TransitTime= 0.20
	Enemy=None
	EnemyAngle=0.0
	aura = None
	swaura=None
	shaura=None
	RWPName=""
	LWPName=""
	FadeList=[]
	luz=None
	
	def __init__(self, me):
		
		EnemyChar.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		
		self.FadeList=[me.Name]
		
		if Actions.StatR(me.Name)!=Actions.RA_NO_WEAPON:
			FadeList.append (me.InvRight)
		if Actions.StatL(me.Name)!=Actions.LA_NO_WEAPON:
			FadeList.append (me.InvLeft)
			
		self.Fader= EntitiesFader (self.FadeList)

		me.AddAnmEventFunc("Disappear", self.DisappearEvent)
		
		me.ImDeadFunc=self.VampImDeadFunc

		me=Bladex.GetEntity(self.Name)
		
		me.Alpha=0.5
		me.SelfIlum=0.6
		
		self.luz = Bladex.CreateEntity(self.Name+"Luz","Entity Spot",0,0,0)
		self.luz.Color       = 50,500,200
		self.luz.Intensity   = 4.0
		self.luz.Precission  = 0.303456
		self.luz.CastShadows = 0
		self.luz.Visible     = 1
		self.luz.SizeFactor  = 0
		me.Link(self.luz)
		
		Bladex.CreateTimer("Timer8",1.0/8.0)

		self.ToolUp()
		
		
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		print EntityName+": newMutilateFunc"
		pass
		
		
		
	def ToolUp(self):
		me=Bladex.GetEntity(self.Name)
		sw=Bladex.CreateEntity(me.Name+"WP","VampWeapon",0,0,0,"Weapon")
		sh=Bladex.CreateEntity(me.Name+"SH","VampShield",0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs (sw)
		sh.Data=ConquestVampShield(sh)
		Sparks.MakeShield(sh.Name)
		#ItemTypes.ItemDefaultFuncs (sh)
		sw.Alpha=0.5
		sh.Alpha=0.5
		sw.SelfIlum=0.5
		sh.SelfIlum=0.5
		self.RWPName=sw.Name
		self.LWPName=sh.Name
		Actions.TakeObject(self.Name,sw.Name)
		Actions.TakeObject(self.Name,sh.Name)
		self.FadeList.append(sw.Name)
		self.FadeList.append(sh.Name)
	
	
	
	
	
	
	
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):	
			return NPCPerson_state
		NPCPerson_state[1]["ConquestVamp"]=(self.Enemy, self.EnemyAngle, self.FadeList)
		return NPCPerson_state		


	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["ConquestVamp"]
			self.Enemy=parms[0]
			self.EnemyAngle=parms[1]
			self.FadeList=parms[2]
		me=Bladex.GetEntity(self.Name)
		self.Fader= EntitiesFader (self.FadeList)
		self.FadeOutTime= 0.45
		self.FadeInTime= 0.65
		self.TransitTime= 0.20
		me.AddAnmEventFunc("Disappear", self.DisappearEvent)
		me.ImDeadFunc=self.VampImDeadFunc

		
			
			
	def VampImDeadFunc (self,EntityName):
		print "vamp issssdead"
		
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
			print "vamp dead func exe"
		else:
			print EntityName+" Has no dead func"
		self.LightDown()
			
			
			
	def LightDown (self):		
		self.luz.TimerFunc= self.DecreaseLightIntensity
		self.luz.SubscribeToList("Timer8")



	def DecreaseLightIntensity(self, ent_name, time):		
		if self.luz.Intensity>0.10:
			self.luz.Intensity=self.luz.Intensity-0.05
		else:
			self.luz.RemoveFromList("Timer8")
			self.luz.TimerFunc=""
			print "vamp light out"
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosVampiro(EntityName)


	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me= Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind= FALSE
			self.AttackNPCTime= 2.0
			inv= me.GetInventory()
			if inv.HoldingShield: 
				me.BlockingPropensity = 1.0
				me.RangeDefenceCapable = TRUE
			else: 
				me.BlockingPropensity = 0.2
				me.RangeDefenceCapable = FALSE
			me.AttackList= BCopy.deepcopy(Combat.VampireAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath= 0.0
	
	
	def FadeOut (self,EntityName):
		self.Fader.FadeOut(self.FadeOutTime)
	
	def FadeIn (self,EntityName):
		self.Fader.FadeIn(self.FadeInTime)


	def DisappearEvent (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		# May wish to make all attacks pass through...
		self.FadeOut(EntityName)
		time= Bladex.GetTime()
		Bladex.AddScheduledFunc(time+self.FadeOutTime+self.TransitTime, self.Reappear, (EntityName,), EntityName+" Reappear")
		if Actions.StatR(EntityName)!=Actions.RA_NO_WEAPON:
			weapon= Bladex.GetEntity(me.InvRight)
			weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
	
	
	def Disappear (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		forgetit= (me.Life*2.0)/CharStats.GetCharMaxLife(me.Kind, me.Level)
		if whrandom.random()>forgetit:# or not Actions.IsFacingEntity(me.GetEnemyName(), EntityName):
			me.SetNextAttack("disappear")
			return 1
		return 0
		
		
	def RelativeEnemyAngle2PositionAngleTuple (self, angle):
		angle= angle+self.EnemyAngle
		# Compensate for non forward attack
		#angle= angle - (25.0/360.0)*Actions.TWOPI
		
		if angle > Actions.PI*2.0:
			angle= angle-Actions.TWOPI
		elif angle < 0.0:
			angle= angle+Actions.TWOPI
		
		# What distance to use?
		pos= self.Enemy.Position
		dist= 1400
		pos= pos[0]+dist*math.sin(angle), pos[1], pos[2]-dist*math.cos(angle)
		return (pos, angle)
	
	
	def Reappear (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		# Find a suitable position to reappear in
		if whrandom.random() < 0.5:
			RelAngles=[0, Actions.PI*0.25, Actions.PI*-0.25, Actions.PI*0.5, Actions.PI*-0.5, Actions.PI*0.75, Actions.PI*-0.75]
		else:
			RelAngles=[0, Actions.PI*-0.25, Actions.PI*0.25, Actions.PI*-0.5, Actions.PI*0.5, Actions.PI*-0.75, Actions.PI*0.75]		
		
		self.Enemy= Bladex.GetEntity(me.GetEnemyName())
		self.EnemyAngle= self.Enemy.Angle
		ReentryInfo= map(self.RelativeEnemyAngle2PositionAngleTuple, RelAngles)
		
		# Add current position, unnecessary
		#ReentryInfo.append ((me.Position, me.Angle))
		
		max_fall= 1000.0
		for info in ReentryInfo:
			if me.TestPos (info[0][0],info[0][1],info[0][2], me.ActionAreaMax,max_fall):
				me.Position= info[0][0],info[0][1],info[0][2]
				me.Angle= info[1]
				me.SetOnFloor()
				break
		
		# Maybe break enemies facing mode
		if self.Enemy.InCombat and self.Enemy.ActiveEnemy==me.Name and not self.Enemy.CanISee(me):
			self.Enemy.SetActiveEnemy(None)
		self.FadeIn(EntityName)
		if Actions.StatR(EntityName)!=Actions.RA_NO_WEAPON:
			
			dice= whrandom.random()
			if dice<0.2:
				me.SetNextAttack("g_01")
			elif dice<0.4:
				me.SetNextAttack("g_06")
			elif dice<0.6:
				me.SetNextAttack("g_07")
			elif dice<0.8:
				me.SetNextAttack("g_26")


	def InteruptActions(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.Data.Fader.Stop()
		Bladex.RemoveScheduledFunc(me.Name+" Reappear")
		
		
	
	
class EntitiesFader(Interpolator.LinearInt):
	

	def __init__(self, Entities2Fade):
		Interpolator.LinearInt.__init__ (self,1.0,0.0)
		self.ObjId=ObjStore.GetNewId() 
		ObjStore.ObjectsStore[self.ObjId]=self

		name= "Entity Fader for; "
		for entity_name in Entities2Fade:
			name= name+entity_name+", "
		self.Interpolator= Interpolator.Interp(name)
		self.Entities2Fade= Entities2Fade

	

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		# Tiene que devolver c䮯 poder guardar el estado de la clase
		return (1,
			self.ObjId,
			self.Interpolator,
			self.Entities2Fade
			)

	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Interpolator=parm[2]
			self.Entities2Fade=parm[3]
			self.init_value=1.0
			self.end_value=0.0
			self.period=self.end_value-self.init_value
		else:
			print "Warning -> Version mismatch in EntitiesFader.__setstate__()"
			self.Interpolator= None
			self.Entities2Fade= None
			self.init_value=1.0
			self.end_value=0.0
			self.period=self.end_value-self.init_value
			
			self.ObjId=ObjStore.GetNewId() 
			ObjStore.ObjectsStore[self.ObjId]=self



	def ExecuteFadeOut(self,value):
		ret= Interpolator.LinearInt.Execute(self,value)
		for entity_name in self.Entities2Fade:
			entity= Bladex.GetEntity(entity_name)
			if entity:
				entity.Alpha= ret
	
	def ExecuteFadeIn(self,value):
		ret= Interpolator.LinearInt.Execute(self,value)
		for entity_name in self.Entities2Fade:
			entity= Bladex.GetEntity(entity_name)
			if entity:
				#entity.Alpha= 1.0-ret
				entity.Alpha= 0.5-ret
	
	def FadeOut(self, period):
		self.Interpolator.Actions=[]
		self.Execute= self.ExecuteFadeOut
		time= Bladex.GetTime()
		self.Interpolator.AddAction (time,time+period,self)
		
		
		
	
	def FadeIn(self, period):
		#pdb.set_trace()
		self.Interpolator.Actions=[]
		self.Execute= self.ExecuteFadeIn
		time= Bladex.GetTime()
		self.Interpolator.AddAction (time,time+period,self)
	
	def Stop(self):
		self.Interpolator.Actions=[]
		
	def EndExecute(self):
		if self.Execute== self.ExecuteFadeIn:
			for entity_name in self.Entities2Fade:
				entity= Bladex.GetEntity(entity_name)
				if entity:
					entity.Alpha= 0.5
		elif  self.Execute== self.ExecuteFadeOut:
			for entity_name in self.Entities2Fade:
				entity= Bladex.GetEntity(entity_name)
				if entity:
					entity.Alpha= 0.0
					
#############################################################################################################################################################################################


class ConquestGreat_Demon (EnemyChar):

	# constants	
	LevelUpTime=0.5
	ImplosionPeriod = 2.5
	DeathBallPeriod = 3.5


	ShieldIntensityMax= 8.0
	ShieldLife= 10000.0

	Fader= None
	FadeOutTime= 0.23333
	FadeInTime= 0.23333
	TransitTime= 0.0

	# variables
	Flame= None
	AGE_Number=0
	Phase= 1			
	shield_light= None
	shield_particle_system= None
	LifeUpCalled=0

	back_aura=None
	front_aura=None

	GDLevelUpParticleData=[]

	def __init__(self, me):
		
		EnemyChar.__init__(self, me)
		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.35
		
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		me.AddAnmEventFunc("Spit", self.StartSpit)
		me.AddAnmEventFunc("Stop_Spit", self.StopSpit)
		me.AddAnmEventFunc("Quake", self.Quake)
		me.AddAnmEventFunc("MagicAttackStart", self.MagicAttackStart)
		me.AddAnmEventFunc("MagicAttackLink", self.MagicAttackLink)
		me.ImDeadFunc=self.ImDeadFunc

		# Create a linear interpolator for fading
		FadeList=[me.Name]
		self.Fader= EntitiesFader (FadeList)
		
		pos= me.Position		
		
		# variables
		self.shield_light= Bladex.CreateEntity(me.Name+" demonic shield light", "Entity Spot", pos[0], pos[1], pos[2])
		me.LinkToNode(self.shield_light,0)
		self.shield_light.Color= 80, 100, 255
		self.shield_light.Intensity= 0.0
		self.shield_light.Precission= 0.03125
		self.shield_light.Visible= 0
		self.shield_light.CastShadows= 0
		
		# more constants
		self.back_aura= Bladex.CreateEntity(me.Name+"_BackAura","Entity Aura",pos[0],pos[1],pos[2])
		self.front_aura= Bladex.CreateEntity(me.Name+"_FrontAura","Entity Aura",pos[0],pos[1],pos[2])
		self.SetAuraIntensity()
		me.Link(self.back_aura)
		me.Link(self.front_aura)
		self.back_aura.SetAuraGradient(2,  0.0, 0.0, 1.0, 0.3, 0.6, 1.0, 1.0, 1.0, 0.0, 1.0)
		self.front_aura.SetAuraGradient(2,  0.0, 0.0, 1.0, 0.1, 0.0  , 1.0, 1.0, 1.0, 0.0, 1.0)
		self.back_aura.SetAuraActive(0)
		self.front_aura.SetAuraActive(0)

		# New data, must be saved and loaded
		self.RingName=""
		
		Bladex.CreateTimer("Timer8",1.0/8.0)
		me.Level= 6
		me.Life= CharStats.GetCharMaxLife(me.Kind, me.Level)
		me.Alpha= 0.85

		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 #va de 0 a 1
				aux=traux**0.5
			else:
				traux=i/25.0 #va de 1 a 0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=300.0*aux
			self.GDLevelUpParticleData.append(a)
			self.GDLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("GDLevelUpParticle",i,r,g,b,a,size)


	# Functions for loading and saving state
	def __getstate__(self):	
		
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		
		shield_light_Name=""		
		if self.shield_light:
			shield_light_Name=self.shield_light.Name
			
		shield_particle_system_Name=""
		if self.shield_particle_system:
			shield_particle_system_Name=self.shield_particle_system.Name
		
		NPCPerson_state[1]["ConquestGreat_Demon"]=(self.Flame,
						self.AGE_Number,
						self.Phase,
						shield_light_Name,
						shield_particle_system_Name,
						self.LifeUpCalled,
						self.RingName)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		
		shield_light_Name=""
		shield_particle_system_Name=""
		me=Bladex.GetEntity(self.Name)
		version=parm[0]
		if version==1:
			parms=parm[1]["ConquestGreat_Demon"]
			self.Flame=parms[0]
			self.AGE_Number=parms[1]
			self.Phase=parms[2]
			
			shield_light_Name= parms[3]
			shield_particle_system_Name=parms[4]
			self.LifeUpCalled=parms[5]
			self.RingName=parms[6]
			
			self.shield_light=Bladex.GetEntity(shield_light_Name)
			self.shield_particle_system=Bladex.GetEntity(shield_particle_system_Name)
			
			# constants				
			self.LevelUpTime=0.5
			self.ImplosionPeriod = 2.5
			self.DeathBallPeriod = 3.5		
			self.LifeUpCalled=0
			me.AddAnmEventFunc("Spit", self.StartSpit)
			me.AddAnmEventFunc("Stop_Spit", self.StopSpit)
			me.AddAnmEventFunc("Quake", self.Quake)
			me.AddAnmEventFunc("MagicAttackStart", self.MagicAttackStart)
			me.AddAnmEventFunc("MagicAttackLink", self.MagicAttackLink)
			#me.ImDeadFunc=self.ImDeadFunc
			self.ShieldIntensityMax= 8.0
			self.ShieldLife= 10000.0
			
			# Create a linear interpolator for fading
			FadeList=[me.Name]
			self.Fader= EntitiesFader (FadeList)
			self.FadeOutTime= 0.23333
			self.FadeInTime= 0.23333
			self.TransitTime= 0.0		
			
			pos= me.Position
			self.back_aura= Bladex.GetEntity(me.Name+"_BackAura")
			self.front_aura= Bladex.GetEntity(me.Name+"_FrontAura")
			self.SetAuraIntensity()
			self.back_aura.SetAuraGradient(2,  0.0, 0.0, 1.0, 0.3, 0.6, 1.0, 1.0, 1.0, 0.0, 1.0)
			self.front_aura.SetAuraGradient(2,  0.0, 0.0, 1.0, 0.1, 0.0  , 1.0, 1.0, 1.0, 0.0, 1.0)
			self.back_aura.SetAuraActive(0)
			self.front_aura.SetAuraActive(0)
			Bladex.CreateTimer("Timer8",1.0/8.0)
			me.Alpha= 0.85
			
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 #va de 0 a 1
				aux=traux**0.5
			else:
				traux=i/25.0 #va de 1 a 0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=300.0*aux
			self.GDLevelUpParticleData.append(a)
			self.GDLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("GDLevelUpParticle",i,r,g,b,a,size)

			
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosGreatDemon(EntityName)
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.2
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.00
			me.AttackList = BCopy.deepcopy(Combat.GreatDemonAttackData)
			#if self.Phase>1 and self.LifeUpCalled:
			#	me.AttackList.append([Combat.ATTACK,  0.03, ("g_quake",),       1000.0, 7000.0, 9000.0, 0.50],)

	def EndPhase1 (self,EntityName):	# Call this for appearance in the House of the Lord of Chaos
		if self.Phase<2:
			me = Bladex.GetEntity(EntityName)
			self.Phase= 2
			me.Level= 9
			me.Life= CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.ResetCombat (EntityName)

	########################################################################
	#____ EARTHQUAKE FUNCS _________________________________________________
	########################################################################
	def ContinueQuake(self, Interval, Delta):
		cam= Bladex.GetEntity("Camera")
		cam.EarthQuakeFactor= cam.EarthQuakeFactor-Delta
		if cam.EarthQuakeFactor > 0.0:
			Bladex.AddScheduledFunc(Bladex.GetTime()+Interval,self.ContinueQuake,(Interval, Delta))
		else:
			cam.EarthQuake=FALSE
		
	def Quake (self,EntityName,EventName):
		QuakeRange= 35000.0
		me=Bladex.GetEntity(EntityName)
		cam= Bladex.GetEntity("Camera")
		mp=me.GraspPos ("Earthquake")
		
		# Shake up physical objects around
		objects_in_range= Bladex.GetEntitiesAt(mp[0], mp[1], mp[2],QuakeRange)
		impulse= 40000.0
		for obj_name in objects_in_range:
			object= Bladex.GetEntity(obj_name)
			if (object.Physic or object.Weapon) and not object.Parent:
				op= object.Position;
				x= op[0]-mp[0]; y= op[1]-mp[1]; z= op[2]-mp[2]
				dist= ((x**2.0) + (y**2.0) + (z**2.0))**0.5
				x,y,z= B3DLib.Normalize((x,y-500.0,z))
				factor= ((QuakeRange-dist)/QuakeRange) * impulse
				object.Impulse(x*factor, y*factor,z*factor)
				if AuxFuncs.GetSpot(object):
					object.OnStopFunc= OnOff.TurnOffLight
		# shake up the player
		victim=Bladex.GetEntity(me.GetEnemyName())
		if victim and victim.Life>0:
			vp= victim.Position
		else:
			vp= cam.Position
		distance= math.sqrt(((mp[0]-vp[0])*(mp[0]-vp[0]))+((mp[1]-vp[1])*(mp[1]-vp[1]))+((mp[2]-vp[2])*(mp[2]-vp[2])))
		severity=max(0.0, 1.0 - distance/QuakeRange)
		
		cam.EarthQuakeFactor=120.0 * severity
		cam.EarthQuake=TRUE
		QuakeTime= 1.5
		Interval= 0.25
		Delta= cam.EarthQuakeFactor/ (QuakeTime/Interval)
		Bladex.AddScheduledFunc(Bladex.GetTime()+Interval,self.ContinueQuake,(Interval, Delta))
		
		if victim and victim.Life>0:
			Damage.DropInvalidObjectsOnImpact (victim.Name)
			victim.Wuea=Reference.WUEA_ENDED
			victim.InterruptCombat()
			if victim.Block:
				if severity<0.5:
					victim.LaunchAnmType("df_01")
				else:
					victim.LaunchAnmType("df_02")
			else:			
				if severity<0.5:
					victim.LaunchAnmType("hurt_f_lite")
				else:
					victim.LaunchAnmType("hurt_f_big")
				# Drop weapons
				if whrandom.random() < severity*0.5:
					object = Bladex.GetEntity(victim.InvLeft)
					if victim.InvLeft and object and not object.TestHit:
						Actions.DropReleaseEventHandler(victim.Name, "DropLeftEvent", FALSE)
						#Actions.RemoveFromInventory (victim, object,"DropLeftEvent")
						#object.Impulse(0.0, 1.0, 0.0) 
				
				if whrandom.random() < severity*0.5:
					object = Bladex.GetEntity(victim.InvRight)
					if victim.InvRight and object and not object.TestHit:
						Actions.DropReleaseEventHandler(victim.Name, "DropRightEvent", FALSE)
						#Actions.RemoveFromInventory (victim, object,"DropRightEvent")
						#object.Impulse(0.0, 1.0, 0.0) 


	
	########################################################################
	#____ MAGIC ATTACK FUNCS _______________________________________________
	########################################################################
	def MagicAttackStart (self, EntityName, EventName):
		me= Bladex.GetEntity(EntityName)
		print "MagicAttackStart "
		# enable damage
		
		# turn off claw damage with a scheduled func after concentration is complete
		MagicStopPos= 0.509
		anm_duration= Bladex.GetAnimationDuration("Gdm_g_magic")		
		DeathTime= Bladex.GetTime()+max((MagicStopPos-me.AnmPos)*anm_duration, 0.0)
		period=0.001
		
		x,y,z= me.GraspPos("1H_L")
		lball=Bladex.CreateEntity(self.Name+"_Fire","Entity Particle System D1",x,y,z)
		lball.ParticleType="Flame"
		lball.PPS=256
		lball.YGravity=-300.0
		lball.Friction=0.04
		lball.RandomVelocity=-30.0 		
		lball.DeathTime= DeathTime
		lball.Time2Live=20
		me.LinkToNode(lball, me.GetNodeIndex("L_Hand"))
		self.lballname= lball.Name		
		self.CreateTestParticle(lball.Name, DeathTime, period)
		
		x,y,z= me.GraspPos("1H_R")
		rball=Bladex.CreateEntity(self.Name+"_Fire","Entity Particle System D1",x,y,z)
		rball.ParticleType="Flame"
		rball.PPS=256
		rball.YGravity=-300.0
		rball.Friction=0.04
		rball.RandomVelocity=-30.0
		rball.DeathTime= DeathTime
		rball.Time2Live=20
		me.LinkToNode(rball, me.GetNodeIndex("R_Forearm"))
		self.rballname= rball.Name		
		self.CreateTestParticle(rball.Name, DeathTime, period)
		
	def MagicAttackLink (self, EntityName, EventName):
		# Create a ring of fire radiating from the floor below the demon
		me= Bladex.GetEntity(EntityName)
		
		# Turn off the flame around the hands
		lball= Bladex.GetEntity(self.lballname)
		if lball: lball.DeathTime= Bladex.GetTime()
		rball= Bladex.GetEntity(self.rballname)
		if rball: rball.DeathTime= Bladex.GetTime()
		
		# Create the firering
		obj=Bladex.CreateEntity(EntityName+"_Disk", "FireRing", 0,0,0)
		obj.Alpha=1.0
		obj.SelfIlum=1.0
		obj.RasterMode="AdditiveAlpha"
		obj.RasterMode="Read"
		obj.Solid= 0

		# Set position & orientation
		me.LinkAnchors("FireRing",obj,"FireRing")
		me.Unlink(obj)
		self.RingName= obj.Name

		TurnOffAfter= 0.4
		AuxFuncs.FadeAndScale(obj.Name, obj.Position, 1.0, 0.0, 0.0, 1.0, 8.0, 0.0, TurnOffAfter, 1, 0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+TurnOffAfter,self.EndOfRingAttack,(EntityName, EventName),"EndOfRingAttack")

				
	
	def EndOfRingAttack (self, EntityName, EventName):
		obj= Bladex.GetEntity(self.RingName)
		if obj:
			me= Bladex.GetEntity(EntityName)
			if me:
				enemy= Bladex.GetEntity(me.GetEnemyName())
				if enemy and enemy.Life>0:
					distSQ= me.SQDistance2(enemy)
					#if distSQ<64000000.0:
					if distSQ<49000000.0:
						# inflict damage
						xhit_point, yhit_point, zhit_point= enemy.Position
						enemy.DamageFunc(enemy.Name, EntityName, self.RingName, "Fire", 1, -1, xhit_point, yhit_point, zhit_point, 0)
						# Override hurt anim
						if enemy.Life>0:
							Damage.DropInvalidObjectsOnImpact (enemy.Name)
							enemy.Wuea=Reference.WUEA_ENDED
							enemy.InterruptCombat()
							if enemy.InCombat: enemy.LaunchAnmType("hurt_f_big")
							else: enemy.LaunchAnmType("hurt_f_big")
			# destroy ring
			obj.SubscribeToList("Pin")
		
		
	########################################################################
	#____ FIRE SPITTING FUNCS ______________________________________________
	########################################################################
	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Great_Demon":
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +300.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]
					
					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						if victim.InCombat:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def CreateTestParticle(self, fireball_name,end_time,period):
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.CreateTestParticle,(fireball_name,end_time,period))
		else:
			pass
			#print "system finished"
	
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		x,y,z= me.GraspPos("ViewPoint")
		self.AGE_Number=self.AGE_Number+1
		node= me.GetNodeIndex("Head")
		# Get an angle to the target
		target= Bladex.GetEntity(me.GetEnemyName())
		target_pos= target.Position
		angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
		print "angle was "+`angle`
		if me.AnimName=="g_spitball":
			# fireball spit
			nparticles= 360
			duration= 2.0/60.0
			end_time=Bladex.GetTime()+duration
			period= duration/7.0
			fireball=Bladex.CreateEntity(EntityName+"_Fireball_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
			fireball.ParticleType="LargeFire"
			fireball.YGravity=-2400
			fireball.Friction=0.03
			fireball.PPS=nparticles/duration
			fireball.DeathTime=end_time;
			F= 25000.0             # Vector magnitude	
			vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
			fireball.Velocity=vx,vy,vz
			fireball.RandomVelocity=50.0
			self.CreateTestParticle(fireball.Name, end_time, period)
		else:
			# flamethrower style
			duration= 20.0
			end_time=Bladex.GetTime()+duration
			period= 0.05
			new_name= EntityName+"_flamethrower_"+`self.AGE_Number`
			print "Creating Flame "+new_name
			if self.Flame:
				self.StopSpit (EntityName,EventName)
			self.Flame=Bladex.CreateEntity(new_name,"Entity Particle System D1",x,y,z)
			self.Flame.ParticleType="Flame"
			self.Flame.PPS=512
			self.Flame.Time2Live=21
			#self.Flame.DeathTime=Bladex.GetTime()+0.75;
			if me.AnimName=="g_spit_around":
				F= 18000.0             # Vector magnitude
				Bladex.AddScheduledFunc(Bladex.GetTime()+5.0, self.StopSpit, (EntityName,""), "StopSpitFunc")
				angle= 	math.fmod(angle+2.8, Actions.TWOPI)
				vx,vy,vz= me.GetDummyAxis("Mouth", -math.cos(angle)*F, -math.sin(angle)*F, 0.0, TRUE)
				self.Flame.Velocity=vx,vy,vz
				self.Flame.RandomVelocity=60.0
				self.Flame.Friction=0.05
				self.Flame.YGravity=-9000.0
			else:
				F= 15000.0             # Vector magnitude
				Bladex.AddScheduledFunc(Bladex.GetTime()+3.85, self.StopSpit, (EntityName,""), "StopSpitFunc")
				angle= 	math.fmod(angle+3.15, Actions.TWOPI)
				vx,vy,vz= me.GetDummyAxis("Mouth", -math.cos(angle)*F, -math.sin(angle)*F, 0.0, TRUE)
				#vx,vy,vz= me.GetDummyAxis("Mouth", F, 0.0, 0.0, TRUE)
				self.Flame.Velocity=vx,vy,vz
				self.Flame.RandomVelocity=50.0
				self.Flame.Friction=0.05
				self.Flame.YGravity=-6000.0
			me.LinkToNode(self.Flame,node)
			self.CreateTestParticle(self.Flame.Name, end_time, period)

	def StopSpit (self,EntityName,EventName):
		if self.Flame:
			print "Stopping Flame "+self.Flame.Name
			self.Flame.DeathTime=Bladex.GetTime()
			self.Flame= None

	########################################################################
	#____ ON HIT FUNCS _____________________________________________________
	########################################################################
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		
		if self.shield_light.Intensity > 0.0:
			damage_absorbed= (self.shield_light.Intensity/self.ShieldIntensityMax) * DamagePoints
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > -damage_absorbed:
				me.Life= me.Life+damage_absorbed
				DamagePoints= max (DamagePoints-damage_absorbed, 0.0)
				current_shield_life= (self.shield_light.Intensity/self.ShieldIntensityMax) * self.ShieldLife
				current_shield_life= current_shield_life - damage_absorbed
				self.shield_light.Intensity = (current_shield_life/self.ShieldLife)*self.ShieldIntensityMax
				self.SetAuraIntensity()
				#print "shield at "+`(self.shield_light.Intensity/self.ShieldIntensityMax)`
				if self.shield_light.Intensity < (self.ShieldIntensityMax/2.0):
					self.ShieldOff (EntityName)
		
		Enm_Def.NPCPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if not self.LifeUpCalled:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life<CharStats.GetCharMaxLife(me.Kind, me.Level) * 0.5:
				self.LifeUp (EntityName)
				self.LifeUpCalled = 1
				self.ResetCombat (EntityName)
				self.ShieldOn (EntityName)
	
	########################################################################
	#____ POWERUP FUNCS ____________________________________________________
	########################################################################
	def LevelUp (self,EntityName,MaxLevel):
		me = Bladex.GetEntity(EntityName)
		me.Level = me.Level +1
		time= Bladex.GetTime()
		if me.Level < MaxLevel:
			Bladex.AddScheduledFunc(time+self.LevelUpTime, self.LevelUp, (EntityName,MaxLevel), EntityName+" LevelUp")
		else:
			self.ResetCombat (EntityName)

	def GDLUP2(self):
		AuraParams=(5, 0, 1, 0, 0, 1)
		AuraGradient=(2, 1.0, 0.6, 0.2, 0.5, 0.0, 1.0, 0.2, 0.05, 0.0, 0.8)
		AuraVar1Args=(5, 300, 0, 1, 1.0)
		AuraVar2Args=(300, 5, 1, 0, 1.5)
		PSParams=(self.GDLevelUpParticleData, "GDLevelUpParticle", 30, 255, 120, 40, 1000, -1000, 0.0, 2, 2, 0.4, 30, 1.6)
		GenFX.LevelUpFX(self.Name, 0, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, 8.0, "Timer15", 15, "..\\..\\Sounds\\aparicion-espada.wav")
		list_of_nodes=("Head", "L_Shoulder", "L_Elbow", "L_Hand", "R_Shoulder", "R_Elbow", "R_Forearm", "Center", "L_Knee", "L_Foot", "R_Knee", "R_Foot")
		GenFX.ElectricDischarge(self.Name, "GDRayLevelUp", 255, 120, 40, 600, list_of_nodes, 10, 1.5)

	def GDLUP1(self,EntityName,EventName):
		pslup=Bladex.CreateEntity("PSGDLifeUp", "Entity Particle System Dperson", 0, 0, 0)
		pslup.PersonName=self.Name
		pslup.ParticleType="GDLifeUpEnergyConc"
		pslup.PPS=600
		pslup.YGravity=0
		pslup.Friction=0.0
		pslup.RandomVelocity=-2
		pslup.NormalVelocity=-30
		pslup.FollowFactor=0.0
		pslup.Time2Live=50
		pslup.Velocity=0.0, 0.0, 0.0
		pslup.DeathTime=Bladex.GetTime()+1.0
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.6, self.GDLUP2, ())

	def LifeUp (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.LaunchAnmType("mgc_df")	
		if self.Phase==1:
			MaxLevel=9
		else:
			MaxLevel=19
		if me.Level < MaxLevel:
			time= Bladex.GetTime()
			Bladex.AddScheduledFunc(time+self.LevelUpTime, self.LevelUp, (EntityName,MaxLevel), EntityName+" LevelUp")
			self.GDLUP1(EntityName,"no_hay_evento")

	########################################################################
	#____ SHIELD FUNCS _____________________________________________________
	########################################################################
	def SetAuraIntensity(self):
		self.back_aura.SetAuraParams(150,self.shield_light.Intensity/self.ShieldIntensityMax,1.0,0,1,1)
		self.front_aura.SetAuraParams(100.0,self.shield_light.Intensity/self.ShieldIntensityMax,1.0,1,0,1)

	def ShieldOn (self,EntityName):				
		self.shield_light.TimerFunc= self.IncreaseShieldIntensity
		self.shield_light.SubscribeToList("Timer8")
		self.SetAuraIntensity()
		self.back_aura.SetAuraActive(1)
		self.front_aura.SetAuraActive(1)
	
	def ShieldOff (self,EntityName):		
		self.shield_light.TimerFunc= self.DecreaseShieldIntensity
		self.shield_light.SubscribeToList("Timer8")
			
	def IncreaseShieldIntensity(self, ent_name, time):		
		self.shield_light.Intensity= min(self.shield_light.Intensity+0.3, self.ShieldIntensityMax)
		self.SetAuraIntensity()
		if self.shield_light.Intensity == self.ShieldIntensityMax:
			self.shield_light.RemoveFromList("Timer8")
			self.shield_light.TimerFunc=""

	def DecreaseShieldIntensity(self, ent_name, time):		
		self.shield_light.Intensity= max(self.shield_light.Intensity-0.3, 0.0)
		self.SetAuraIntensity()
		if self.shield_light.Intensity == 0.0:			
			self.shield_light.RemoveFromList("Timer8")
			self.shield_light.TimerFunc=""
			self.back_aura.SetAuraActive(0)
			self.front_aura.SetAuraActive(0)

	########################################################################
	#____ DEATH FUNCS ______________________________________________________
	########################################################################
	def RemoveMe (self,EntityName):
		me  = Bladex.GetEntity(EntityName)
		if me:
			me.Alpha=0.0
			me.TimerFunc=""
			me.SubscribeToList("Pin")
		
	def FadeOut (self,EntityName):
		self.Fader.FadeOut(self.FadeOutTime)

	def DeathBall (self,EntityName):
		me  = Bladex.GetEntity(EntityName)
		if me:
			alfa=me.Angle+3.14159/2.0
			x=me.Position[0]+500.0*math.cos(alfa)
			y=me.Position[1]+250.0
			z=me.Position[2]+500.0*math.sin(alfa)
			me.RasterMode="Read"
			self.deathball_particle_system=Bladex.CreateEntity("BolaFuego", "Entity Particle System D1", x, y, z)
			self.deathball_particle_system.ParticleType="FuegoInvocacion"
			self.deathball_particle_system.PPS=250
			self.deathball_particle_system.YGravity=0.0
			self.deathball_particle_system.Friction=0.1
			self.deathball_particle_system.Velocity=0.0, 0.0, 0.0
			self.deathball_particle_system.RandomVelocity=50.0
			self.deathball_particle_system.Time2Live=40
			self.deathball_particle_system.DeathTime= Bladex.GetTime()+self.DeathBallPeriod
			self.FadeOutTime=self.DeathBallPeriod*0.8
			#pdb.set_trace()
			self.FadeOut(EntityName)
			
			# After the fade out, remove me from the world
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.DeathBallPeriod*0.9, self.RemoveMe, (EntityName,))

	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		me.UnlinkChildren()
		
		
		# switch off shield if activated
		if self.shield_light:
			self.shield_light.RemoveFromList("Timer8")
			self.shield_light.TimerFunc= self.DecreaseShieldIntensity
			self.shield_light.SubscribeToList("Timer8")
		
		if self.shield_particle_system:
			self.shield_particle_system.DeathTime= Bladex.GetTime()
			self.shield_particle_system= None
		
		# Create an implosive particle system
		impl=Bladex.CreateEntity("ImplosionDemonio", "Entity Particle System D1", me.Position[0], me.Position[1], me.Position[2])
		impl.ParticleType="Energia3"
		impl.YGravity=0.0
		impl.Friction=0.0
		impl.PPS=300
		impl.Velocity=0.0, 0.0, 0.0
		impl.RandomVelocity=-30.0
		impl.Time2Live=70
		impl.DeathTime=Bladex.GetTime()+(self.ImplosionPeriod*0.5)
		
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+self.ImplosionPeriod, self.DeathBall, (EntityName,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
			print "Demon Dead Func Called"