import Bladex
import Basic_Funcs
import GameStateAux
import ItemTypes
import Damage
import Reference
import CharStats
import GenFX
import Sparks
import ObjStore
import math

import Actions
import BUIx

TRUE = 1==1
FALSE = not TRUE

###################################################################
#### Set To 0 to disable combo damage FX in case of OGL crashes

DamageFX=0

if DamageFX==0:
	Damage.InflictDamageFXData={}

###################################################################

def RemapKeys():
	
	import acts
	print "New Remap keys"
	Bladex.AddBoundFunc("LaunchTravel",ExecTravelBook)
	Bladex.RemoveBoundFunc("LaunchTravel",acts.ExecTravelBookNP)
	Bladex.AddBoundFunc("Throw Left",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.AddBoundFunc("Block",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.RemoveBoundFunc("Throw Left",Actions.TestThrowLeft)
	Bladex.RemoveBoundFunc("Block",Actions.TestThrowLeft)	
	Bladex.AddBoundFunc("Block",acts.DefArgWrapper ("Player1", CheckDropBow))
	
	
	
	
	
# Dropping Bows 8/)
	
def TryDropLeftBow (EntityName):
	
	me = Bladex.GetEntity(EntityName)
	statL=Actions.StatL(me.Name)
	statR=Actions.StatR(me.Name)
	if statL == Actions.LA_BOW:
		
		inv=me.GetInventory()
		if me.InvRight and Reference.GiveObjectFlag(me.InvRight)==Reference.OBJ_ARROW:
			Actions.SheatheArrow(inv, me.InvRight)
		object = Bladex.GetEntity(me.InvLeft)
		object.ExcludeHitFor(me)
		me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.0,me.LaunchAnmType,("drp_l",))
		return TRUE
		
	elif statL <> Actions.LA_NO_WEAPON:
		object = Bladex.GetEntity(me.InvLeft)
		if Actions.IsValidForDropping (object.Name):
			object.ExcludeHitFor(me)
			me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
			me.LaunchAnmType("drp_l")
			return TRUE
			
		else:
			ReportMsg ("Cannot be dropped")
	else:
		return FALSE

	
	
def CheckDropBow(EntityName):
	
	me = Bladex.GetEntity(EntityName)
	throw_pressed = Bladex.GetTimeActionHeld ("Throw")
	if not throw_pressed:
		return
	TryDropLeftBow (EntityName)

##############################################################################################################################


def PlayerHasKnightshade():
	print "Check if got knightshade"
	if Bladex.GetEntity("Player1").Data.HasKnightshade:
		print "Yup"
		return 1
	print "Nope"
	return 0

class GladiatorTravelBook(BUIx.B_RectWidget):
	def __init__(self,Parent,Menudesc,StackMenu,VertPos=0):
		import Language
		import Raster
		self.index = 1
		self.images = []
		self.vidw = 1
		self.vidh = 1
		char = Bladex.GetEntity("Player1")
		Raster.UnifyRenderBuffers()
		
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\Items\\plantillaGitems.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaweapons.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillahabilities.jpg")
		
		#  Knightshade stuff
		if PlayerHasKnightshade():
			print "Player Has nightshade"
			if char.Kind=="Barbarian_N": 		
				self.AddImage("..\\..\\Maps\\NewConquest\\BarKnightshade.jpg")
			elif char.Kind=="Dwarf_N": 		
				self.AddImage("..\\..\\Maps\\NewConquest\\DwfKnightshade.jpg")
			elif char.Kind=="Amazon_N": 		
				self.AddImage("..\\..\\Maps\\NewConquest\\AmzKnightshade.jpg")
			else:
				self.AddImage("..\\..\\Maps\\NewConquest\\KgtKnightshade.jpg")
			
		BUIx.B_RectWidget.__init__(self,Parent,Menudesc["Name"],self.vidw,self.vidh)
		self.Selected=0
		self.Solid=0
		self.Border=0
		self.SetDrawFunc(self.Draw)
		self.SndCorreGema=Bladex.CreateSound("..\\..\\Sounds\\golpe-metal-mediano.wav","Chanje")
		self.SndCorreGema.Volume=0.3
		self.SndCorreGema.MinDistance=1000000.0
		self.SndCorreGema.MaxDistance=2000000


	def AddImage(self, file):
		import BBLib
		image = BBLib.B_BitMap24()
		image.ReadFromFile(file)
		self.images.append(image)
		print "Adding Image"

	def Draw(self,x,y,time):
		import Menu
		import Raster
		char = Bladex.GetEntity("Player1")
		x,y = Raster.GetSize()
		Raster.SetPosition((x - 640)/2, (y - 480)/2)
		if self.index < 0:
			self.index = len(self.images) - 1
		if self.index > len(self.images) - 1:
			self.index = 0
		Raster.DrawImage(640,480,"BGR","Normal",self.images[self.index].GetData())
		self.DefDraw(x,y,time)

	def FinalRelease(self):
		BUIx.B_RectWidget.FinalRelease(self)

	def AcceptsFocus(self):
		return 1

	def IncMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index + 1

	def DecMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index - 1

	def GetFocus(self):
	    return self

	def ActivateItem(self,activate):
		import Menu
		Menu.ActivateMenu()


def ExecTravelBook():
	print "OPPeNNing Travel Book"
	import Menu
	import GameText
	import Scorer
	import acts
	GameText.AbortText()
	if not Menu.MENU_PREACTIVATED:
		try:
			Menu.TB_ACTIVATED=1
		except:
			pass
		Menu.MENU_PREACTIVATED = 1
		pepote = Menu.Desc1
		Menu.Desc1={"Name":"TopMenu","FrameKind":GladiatorTravelBook,"ListDescr":[{"Name":"Back","Kind":GladiatorTravelBook}]}
		Menu.ActivateMenu()
		Menu.Desc1 = pepote
		Scorer.HideTBS()
		for kn in acts.GetKeyList("Turn Left"):
			if kn!="Left":
				Bladex.AssocKey("Menu Dec","Keyboard",kn)
		for kn in acts.GetKeyList("Turn Right"):
			if kn!="Right":
				Bladex.AssocKey("Menu Inc","Keyboard",kn)
	
###############################################################################################################################################




########### damage multipliers

## Knight

#gladius
Damage.AnimationData['Kgt_g_28new']=   8.0
#maza
Damage.AnimationData['Kgt_g_01_new']=   12.0
#espadaromana
Damage.AnimationData['Kgt_g_27kata_new']=   7.0
#elfsword
Damage.AnimationData['Kgt_g_32_5_3new']=   5.0
#maza2
Damage.AnimationData['Kgt_g_21_6_s8new']=   9.0
#hooksword
Damage.AnimationData['Kgt_g_s22low_new']=   12.0
#espadacurva
Damage.AnimationData['Kgt_g_sb25_new']=   9.0

#cimitarra
Damage.AnimationData['Kgt_g_18_11_22_new']=  10.0


#espadafilo
Damage.AnimationData['Kgt_g_09_07_s6low_new']=  15.0
#espada
Damage.AnimationData['Kgt_g_29_3new']=   20.0



Damage.AnimationData['Kgt_g_3s9_6new']=  3.5
Damage.AnimationData['Kgt_g_back']=   2.8
Damage.AnimationData['Kgt_g_bad_axe']=   1.6
Damage.AnimationData['Kgt_g_bad_sword']=   1.0
Damage.AnimationData['Kgt_g_bad_sword2']=   1.3
Damage.AnimationData['Kgt_g_bad_sword3']=   1.5
Damage.AnimationData['Kgt_g_bad_spear']=   1.9
Damage.AnimationData['Kgt_g_bad_spear2']=   1.9

###########




#deathsword
Damage.AnimationData['Bar_g2h_b6low']=   9.0

#chaossword
Damage.AnimationData['Bar_g2h_b6']=   8.0

#longsword
Damage.AnimationData['Bar_g2h_13']=    11.0

#sawsword
Damage.AnimationData['Bar_g2h_21_7']=   28.0


#comborapidoextra1
Damage.AnimationData['Bar_g2h_21_6kata']=   5.0     # DeathDealer
#comborapidoextra2
Damage.AnimationData['Bar_g2h_26_b6']=   9.0        # Hellwind

Damage.AnimationData['Bar_g2h_b6']=   6.5

#comboaleatorioextra
Damage.AnimationData['Bar_g_axe31']=   10.0

####
Damage.AnimationData['Amz_g_spear_21']=   15.0
Damage.AnimationData['Amz_g_spear_2katab6low']= 10.0
Damage.AnimationData['Amz_g_spear_sb11']=   24.0
Damage.AnimationData['Amz_g_spear33']=  16.0

####

Damage.AnimationData['Dwf_g_s3_new']=   15.0 # eagles eye
Damage.AnimationData['Dwf_g_back']=   3.0
Damage.AnimationData['Dwf_g_31']=   24.0 # demolition
Damage.AnimationData['Dwf_g_17']=   30.0 # liberator
Damage.AnimationData['Dwf_g_21']=   10.0  # double smash
Damage.AnimationData['Dwf_g_16']=   11.0   # slashback
Damage.AnimationData['Dwf_g_12']=   12.0    # bonebreaker


BreakableShields=("Escudo6","Escudo1","Escudo2","Escudo3","Escudo4","Escudo5","Escudo7","Escudo8","Escudo9","KingShield")


def InflictDestructorDamage (special, special_resistance, effective_damage, VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):	
	print "Destructor"
	if VictimName:
		print VictimName
	victim= Bladex.GetEntity(VictimName)
	if victim:
		lwp=Bladex.GetEntity(victim.InvLeft)
		if lwp and Reference.IsParryingType(lwp.Kind) and lwp.Kind in BreakableShields:
		
		
		
			Reference.EntitiesObjectData[lwp.Name]=Reference.DefaultObjectData[lwp.Kind]
			Reference.EntitiesObjectData[lwp.Name][2]=1  # Weaken shield if enemy has one
			
				
				
			print "enemy shield weakened: ",lwp.Kind			
	return 0.0








Damage.SpecialDamageFuncs['Destructor']   = InflictDestructorDamage


Bladex.AddParticleGType("KnightshadeParticle","GenericParticle2", Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>10:
		traux=(60.0-i)/50.0 
	else:
		traux=i/10.0 
	r=55
	g=170
	b=50
	a=170.0*traux
	size=225.0*(1-i/60.0)**2.0
	Bladex.SetParticleGVal("KnightshadeParticle",i,r,g,b,a,size)




Bladex.AddParticleGType("GasVenenoso3","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=110
	g=70
	b=50
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("GasVenenoso3",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("GasVenenoso4","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=90
	g=110
	b=80
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("GasVenenoso4",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("GasVenenoso5","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=180
	g=180
	b=40
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("GasVenenoso5",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("SandyDust","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	aux=(64.0-i)/64.0
	r=180
	g=140
	b=40
	a=255.0*(1.0-aux)**0.5
	size=80.0+aux*900.0
	Bladex.SetParticleGVal("SandyDust",i,r,g,b,a,size)
	
	
	

def UpdateKnighshade():
	try:
		dk=Bladex.GetEntity("Knightshade")
		dk.Data.SetDamage()
	except:
		print "Knightshade NOT upgraded"
		pass



class Player (Basic_Funcs.PlayerPerson):

	LevelupFunc=None
	KilledEnemyFunc=None
	DeathFunc=None
	HasKnightshade=0
	
	def __init__(self, me):
		Basic_Funcs.PlayerPerson.__init__(self, me)
		
		
		self.DeathFunc=None
		self.KilledEnemyFunc=None
		self.LevelupFunc=None
		self.HasKnightshade=0
		me.ImDeadFunc=self.NewImDeadFunc
		
		
		
	def OnKilledEnemy(self,KilledEntityName):
		
		if self.KilledEnemyFunc:
			apply(self.KilledEnemyFunc)
	
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		me=Bladex.GetEntity(self.Name)
		if me.Life<=0:
			return
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		
	
		if me.PartialLevel>=LevelLimit:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			self.LevelUpFX()
	
	
	def FastrackLevelup(self,EntityName, lvl=17):
		me=Bladex.GetEntity(EntityName)
		me.Level=lvl
		self.LevelUpFX()
	
	
	def LevelUpFX(self):
		me=Bladex.GetEntity(self.Name)
		import Scorer
		Scorer.LevelUp()
		Scorer.SetLevelLimits(0,CharStats.GetCharExperienceCost(me.CharType,me.Level))
		maxlevel=CharStats.GetMaxLevel()
		maxsize=50+(140/maxlevel)*me.Level 
		maxPPS=120+(600/maxlevel)*me.Level 
		maxint=0.5+(4.5/maxlevel)*me.Level 
		AuraParams=(5, 0, 1, 0, 0, 1)
		AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
		AuraVar1Args=(5, maxsize, 0, 1, 0.5)
		AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
		PSParams=(self.LevelUpParticleData, "LevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
		GenFX.LevelUpFX("Player1", 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15, "..\\..\\Sounds\\aparicion-escudo.wav")
		# Restore state of the player.
		if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
			me.ResetWounds()
		
			me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
		if self.LevelupFunc:
			apply(self.LevelupFunc)
		
		Scorer.SetLevelBarValue(me.PartialLevel)
		UpdateKnighshade()
		print "Levelup"
	
	
	def GetResistance(self, DamageType):
		if self.Resistances.has_key(DamageType): 
			resistance= self.Resistances[DamageType]
		else: resistance= 0.0
		resistance= min(resistance,1.0)
		
		# Do we have any items that offer protections aginst this damage
		me=Bladex.GetEntity(self.Name)
		if me:
			inv= me.GetInventory()
			for i in range (inv.nKindObjects):
				obj_name= inv.GetObject(i)
				object= Bladex.GetEntity(obj_name)
				try:
					if object.Data:
						if object.Data.Resistances:
							if object.Data.Resistances.has_key(DamageType):
								
								extra_resistance= object.Data.Resistances[DamageType]*(1.0-resistance)
								resistance= resistance+extra_resistance
								resistance= min(resistance,1.0)
				except AttributeError: pass
			for i in range(inv.nWeapons):
				wp= inv.GetWeapon(i)
				thing=Bladex.GetEntity(wp)
				
				try:
					if thing.Data:
						if thing.Data.Resistances:
							print "I have a weapon which gives extra resistance"
							if thing.Data.Resistances.has_key(DamageType):
								print "to "+DamageType
								extra_resistance= thing.Data.Resistances[DamageType]*(1.0-resistance)
								resistance= resistance+extra_resistance
								resistance= min(resistance,1.0)
				except AttributeError: 
					pass
		return resistance	
	
	
	
	
	
	def NewImDeadFunc(self, EntityName):
		print "Player1 - Dead"
		me = Bladex.GetEntity(EntityName)
		if self.DeathFunc:
			apply(self.DeathFunc)
			nents= Bladex.nEntities()
			for i in range(nents):
				ent= Bladex.GetEntity(i)
				if (ent.Person):
					if ent.Life>0:
						try:
							if ent.Data.NameOfEnemy==EntityName: 
								ent.ResetChase()
						except:
							pass
		else:
			Basic_Funcs.PlayerPerson.PCImDead(self,EntityName)
	
	
	
			
			
	def __getstate__(self):	
		PlayerPerson_state=Basic_Funcs.PlayerPerson.__getstate__(self)
		if(PlayerPerson_state[0]!=1):
			return PlayerPerson_state
		PlayerPerson_state[1]["Player"]=(
		                                 GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                 GameStateAux.SaveFunctionAux(self.DeathFunc),
		                                 GameStateAux.SaveFunctionAux(self.KilledEnemyFunc),
		                                 self.HasKnightshade
						 )
		return PlayerPerson_state
	
	
	def __setstate__(self,parm):
		Basic_Funcs.PlayerPerson.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)
		version=parm[0]
		if version==1:
			parms=parm[1]["Player"]
			GameStateAux.LoadFunctionAux(parms[0],self,"LevelupFunc")
			GameStateAux.LoadFunctionAux(parms[1],self,"DeathFunc")
			GameStateAux.LoadFunctionAux(parms[2],self,"KilledEnemyFunc")
			self.HasKnightshade=parms[3]
			#me.DamageFunc=PlayerDamage
			me.ImDeadFunc=self.NewImDeadFunc  
			
			
################################################################################################################################################################################################
############### Knightshade Weapon

SwordHit=[5,8,15,25,35,50,65,85,100,110,120,130,140,150,160,170,180,190,200,250,300,400,400,400]


class KnightshadeWeapon(ItemTypes.PersistantItemType):
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		
		self.Ice=0
		self.Fire=0
		self.Drain=0
		self.Electric=0
		self.Light=0
		self.Venom=0
		self.Destructor=0
		self.Name= me.Name
		self.Owner="Player1"
		self.Resistances= {}
	
		Reference.EntitiesSelectionData[self.Name]=(9.0,6000.0,"Knightshade")
		self.SetDamage()
		me.SelfIlum=0.5
		if me.Kind [:-1] == "B" or me.Kind [:-1] == "A":
			Sparks.MakeShield(me.Name)
			print "Knightshade made shield"
			
		self.luz=Bladex.CreateEntity(me.Name+"Luzblu","Entity Spot",0, 0, 0)
		self.luz.Color=50,150,100
		self.luz.Intensity=1.1
		self.luz.Precission=0.125
		self.luz.CastShadows=0
		self.luz.Visible=0
		self.luz.Flick=0   
		self.luz.SizeFactor = 0.2
		self.luz.AngVel=0.1
		me.Link(self.luz)	

		Bladex.CreateTimer("Timer8",1.0/8.0)


	 
		AddKSWeaponFX(me.Name, self) #######
		
		
	
	def LuzFlare(self):
		self.luz.TimerFunc= self.LuzFlareTimer
		self.luz.SubscribeToList("Timer8")
	
	def LuzFlareTimer(self, ent_name, time):
		if self.luz.Intensity>24.0:
			self.luz.RemoveFromList("Timer8")
			self.luz.TimerFunc=""
		else:
			self.luz.Intensity=self.luz.Intensity+1.00
	
	
	
	def LightDownToNormal(self):
		self.luz.TimerFunc= self.LightDownToNormalTimer
		self.luz.SubscribeToList("Timer8")
	
	def LightDownToNormalTimer(self, ent_name, time):
		if self.luz.Intensity<1.6:	
			self.luz.RemoveFromList("Timer8")
			self.luz.TimerFunc=""
		else:
			self.luz.Intensity=self.luz.Intensity-0.5
	
	
	
	
		
		
		
	def SetDamage(self):
		me=Bladex.GetEntity(self.Name)
		dam=100
		lvl=8
		owner = Bladex.GetEntity(self.Owner)
		
		if not owner:
			return
		lvl=owner.Level+1
		dam = 400
		if owner.Level <= 19:
			dam = SwordHit[lvl]
		print "Knightshade damage set to ",dam
		if me.Kind =="Knightshade_B":
			Reference.EntitiesObjectData[me.Name]= [Reference.OBJ_WEAPON, dam, 0, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,500,6000,Reference.GolpeArmaEscudoMetal]]
		elif me.Kind == "Knightshade_A":
			Reference.EntitiesObjectData[me.Name]= [Reference.OBJ_WEAPON, dam, 0, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_SP,Reference.PI,2000,750,500,6000,Reference.GolpeArmaEscudoMetal]]
		else:
			Reference.EntitiesObjectData[me.Name]= [Reference.OBJ_WEAPON, dam, 0, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
			
		if self.Fire:
			Reference.EntitiesObjectData[self.Name].append(['Fire', +200.0])
		if self.Ice:
			Reference.EntitiesObjectData[self.Name].append(['Ice', +200.0])
		if self.Venom:
			Reference.EntitiesObjectData[self.Name].append(['Venom', +30.0])
		if self.Drain:
			Reference.EntitiesObjectData[self.Name].append(['Drain'])
		if self.Electric:
			Reference.EntitiesObjectData[self.Name].append(['Electric', +500.0])
		if self.Light:
			Reference.EntitiesObjectData[self.Name].append(['Light', +250.0])
		if self.Destructor:
			Reference.EntitiesObjectData[self.Name].append(['Destructor'])
			print "Adding Desructor to "+self.Name
		print "Knightshade Upgrade"
			
		
	def AddFire(self):
		self.Fire=1
		self.SetDamage()
		self.Resistances['Fire']= 0.8
		
	def AddIce(self):
		self.Ice=1
		self.SetDamage()
		self.Resistances['Ice']= 0.8
		
	def AddVenom(self):
		self.Venom=1
		self.SetDamage()
		self.Resistances['Venom']= 1.0
		
	def AddDrain(self):
		self.Drain=1
		self.SetDamage()
		self.Resistances['Drain']= 1.0
		
		
		
		
	def AddElectric(self):
		self.Electric=1
		self.SetDamage()
		self.Resistances['Electric']= 0.8
		
	def AddLight(self):
		self.Light=1
		self.SetDamage()
		self.Resistances['Light']= 0.8
		
	def AddDestructor(self):
		self.Destructor=1
		self.SetDamage()
		
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		
		Luz_Name=""		
		if self.luz:
			Luz_Name=self.luz.Name
		state[1]["KnightshadeWeapon"]=(self.Ice,
			         	       self.Fire,
					       self.Drain,
					       self.Electric,
					       self.Light,
					       self.Venom,
					       self.Destructor,
					       self.Name,
					       self.Owner,
					       Luz_Name,
					       self.Resistances)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		Luz_Name=""
		if parm[0]==1:
			parms=parm[1]["KnightshadeWeapon"]
			self.Ice=parms[0]
			self.Fire=parms[1]
			self.Drain=parms[2]
			self.Electric=parms[3]
			self.Light=parms[4]
			self.Venom=parms[5]
			self.Destructor=parms[6]
			self.Name=parms[7]
			self.Owner=parms[8]
			Luz_Name= parms[9]
			self.luz=Bladex.GetEntity(Luz_Name)
			self.Resistances=parms[10]
		else:
			self.Ice=0
			self.Fire=0
			self.Drain=0
			self.Electric=0
			self.Light=0
			self.Venom=0
			self.Destructor=0
			self.Name=""
			self.Owner="PLayer1"
			self.luz=""
			self.Resistances= {}
		#AddKSWeaponFX(me.Name, self)
		Bladex.CreateTimer("Timer8",1.0/8.0)
			
			
			
			
			
class KSWeaponFX:

	def __init__(self, WeaponName, auraparams,auragradient):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		weapon=Bladex.GetEntity(WeaponName)
		self.WeaponName=WeaponName
		self.Aura=None
		
		if auraparams:
			s, a, ci, f, b, am=auraparams
			m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd=auragradient
			self.Aura=Bladex.CreateEntity(WeaponName+"Aura", "Entity Aura", 0, 0, 0)
			self.Aura.SetAuraParams(s, a, ci, f, b, am)
			self.Aura.SetAuraGradient(m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd)
			weapon.Link(self.Aura)
			self.Aura.SetAuraActive(1)
		

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.WeaponName,
				GameStateAux.SaveEntityAux(self.Aura)
			)


	def __setstate__(self,parm):
		print "GenFX.__setstate__()",parm
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.WeaponName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
		else:
			self.WeaponName=""
			self.Aura=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self



def AddKSWeaponFX(WeaponName, data):
	weapon=Bladex.GetEntity(WeaponName)
	if not weapon:
		print "El arma especificada no existe!"
		return
	if not data:
		InitDataField.Initialise(weapon)
		data= weapon.Data
	auraparams=(40, 1, 1, 0, 0, 0)
	auragradient=(2, 0.2, 0.8, 3.0, 0.2, 0.0, 0.0, 0.8, 2.0, 0.1, 0.5)
		

	data.KSWeaponFX=KSWeaponFX(WeaponName, auraparams,auragradient)


######################

"""
def LoseShield2(entity):
	per = Bladex.GetEntity(entity)
	
	esc=Bladex.GetEntity(per.InvLeft)
	if not esc:
		return
	if Reference.EntitiesObjectData.has_key(per.InvLeft):
		del Reference.EntitiesObjectData[per.InvLeft]
	Reference.EntitiesSelectionData[esc.Name]=()
	#Damage.DropInvalidObjectsOnImpact (entity)
	inv=per.GetInventory()
	inv.RemoveShield(esc.Name)
	inv.LinkLeftHand("None")
	imp1,imp2,imp3=per.Rel2AbsVector(20000.0, -15000.0, 0.0)
	esc.Impulse(imp1,imp2,imp3)
	if per.Data.NPC:
		per.Data.ResetCombat(entity)
	print "OK"



def LoseShield(entity):
	per = Bladex.GetEntity(entity)
	if per.InvLeft:
		print "I have a shield"
		esc=Bladex.GetEntity(per.InvLeft)
		if esc:
			
			per.Wuea=Reference.WUEA_ENDED
			per.LaunchAnmType("df_s_broken")
			
			Bladex.AddScheduledFunc(Bladex.GetTime() + 0.15,LoseShield2,(entity,))
			
			
			
			
			
		




import BCopy

class MingyueShield:
	def __init__(self, me):
	
		self.ObjId=ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]=self
		
		
		me.Weapon=1
		self.Name= me.Name
		self.Rebound= 0.6
		self.aura=None
		self.Pb=None
		self.Defense=1000
		self.Spdamage=["",+1]
		pos= me.Position
			
		self.aura=Bladex.CreateEntity(me.Name+"_Aura","Entity Aura",pos[0],pos[1],pos[2])
		self.aura.SetAuraParams(20, 1, 1, 0, 0, 1)
		self.aura.SetAuraGradient(2, 0.9, 1.0, 1.0, 0.2, 0.1, 0.4, 0.8, 1.0, 0.2, 1.0)
		

		me.Link(self.aura)
		self.aura.SetAuraActive(1)
		me.SelfIlum=0.4
		me.Alpha=0.6
		
		self.Pb=Bladex.CreateEntity(me.Name+"Particles", "Entity Particle System Dobj",pos[0],pos[1],pos[2])
		self.Pb.ObjectName=me.Name
		self.Pb.ParticleType= "FastEnergyConc" 
		self.Pb.PPS=128
		self.Pb.YGravity=-350
		self.Pb.Friction= 1.0 #0.02
		self.Pb.FollowFactor=0.8
		self.Pb.Velocity=0.0, 0.0, 0.0
		self.Pb.RandomVelocity=0.5
		self.Pb.NormalVelocity=0.0
		self.Pb.Time2Live=20
		
		

		
		kind = Bladex.GetEntity(self.Name).Kind
		if Reference.DefaultObjectData.has_key(kind):
			Reference.EntitiesObjectData[self.Name]= BCopy.deepcopy(Reference.DefaultObjectData[kind])
			self.Defence= Reference.EntitiesObjectData[self.Name][2]
		else:
			print "Error -- Cannot find default object data for "+kind
			self.Defence= 1000
			self.IntDefence= 0






	def AbsorbFunc (self, AttackerName, WeaponName, DamagePoints):
		me=Bladex.GetEntity(self.Name)
		self.Defense=Reference.EntitiesObjectData[self.Name][2] 
		if self.Defense == 0.0:
			if self.aura:
				self.aura.SetAuraActive(0)
				me.Unlink(self.aura)	
				print "Aura unlinked"
				self.aura=None
				if self.Pb: #add this line
					self.Pb.DeathTime=Bladex.GetTime()+1.0 # add this line
				if me.Parent:
					owner=Bladex.GetEntity(me.Parent)
					LoseShield(me.Parent)
				return
			else:
				print "no aura?"
		
		attacker= Bladex.GetEntity(AttackerName)
		
		if attacker and attacker.Person:
			effective_damage= max(DamagePoints*self.Rebound, 0.0)
			
			if attacker.Life>0:
				if self.Spdamage[0] !="":
					special_resistance= attacker.Data.GetResistance(self.Spdamage[0])
			
					if Damage.SpecialDamageFuncs.has_key(self.Spdamage[0]):
						special_damage_func= Damage.SpecialDamageFuncs[self.Spdamage[0]]
						special_damage_func (self.Spdamage, special_resistance, effective_damage, AttackerName, None, self.Name, self.Spdamage[0], Reference.BODY_FRONT, 0, 0, 0, 0, 0)
			
			
				LastDamage= min (effective_damage, attacker.Life)
				attacker.Life= attacker.Life-LastDamage
				attacker.Wuea=Reference.WUEA_ENDED
				attacker.InterruptCombat()
				attacker.LaunchAnmType("hurt_f_big")
				print"Yooow!"
				
				LastDamage= min (effective_damage, attacker.Life)
				DamageZone=Reference.BODY_FRONT
				DamageType=self.Spdamage[0]
				
				attacker.Data.RespondToHit(AttackerName, self.Name, LastDamage, DamageType, DamageZone, 0)
				
					
		
	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.Name,
				self.Rebound,
				self.Defense,
				self.Spdamage
				)

	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=parm[2]
			self.Rebound=parm[3]
			self.Defense=parm[4]
			self.Spdamage=parm[5]
		else:
			
			self.ObjId=ObjStore.GetNewId() 
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=""
			self.Name=""
			self.Rebound=0.6
			self.Defense=1000
			self.Spdamage=["",+1]
		
		if self.Defense>0:
			me=Bladex.GetEntity(self.Name)
			self.aura=Bladex.CreateEntity(me.Name+"_Aura","Entity Aura",pos[0],pos[1],pos[2])
			self.aura.SetAuraParams(10, 1, 1, 0, 0, 1)
			self.aura.SetAuraGradient(2, 0.9, 1.0, 1.0, 0.2, 0.1, 0.4, 0.8, 1.0, 0.2, 1.0)
			me.Link(self.aura)
			self.aura.SetAuraActive(1)
			
			
			
"""