import Bladex
import Reference
import BCopy
import AuxFuncs





class Quiver:
	def __init__ (self, me):
		me.Static=0

		object_data = None
		if Reference.EntitiesObjectData.has_key(me.Name):
			object_data = Reference.EntitiesObjectData[me.Name]
		elif Reference.DefaultObjectData.has_key(me.Kind):
			object_data = Reference.DefaultObjectData[me.Kind]
		if object_data:
			self.MaxArrows= object_data[1]
			self.ArrowType= object_data[2]
		else:
			self.MaxArrows= 12
			self.ArrowType="Flecha"
			
			
			
		self.MaxArrows= 12
		self.ArrowsLeft= self.MaxArrows
		self.ArrowsFriendlyName= self.ArrowType

		self.Name= me.Name
		
		
		self.BaseKind= me.Kind
		if len(self.BaseKind)>=2 and self.BaseKind[len(self.BaseKind)-2:len(self.BaseKind)-1]=='_':
			self.BaseKind= self.BaseKind[:len(self.BaseKind)-2]
		elif len(self.BaseKind)>=1 and self.BaseKind[len(self.BaseKind)-1:]=='1':
			self.BaseKind= self.BaseKind[:len(self.BaseKind)-1]
		elif len(self.BaseKind)>=1 and self.BaseKind[len(self.BaseKind)-1:]=='2':
			self.BaseKind= self.BaseKind[:len(self.BaseKind)-1]
		self.ArrowsUsed= 0
		self.ArrowCache=[]
		for i in range (self.MaxArrows):
			self.ArrowCache.append (self.Name+"_Arrow_"+`i`)
			

	def GetFirstArrow (self, allow_parented=0, allow_flying=0):
		for arrow_name in self.ArrowCache:
			arrow= Bladex.GetEntity (arrow_name)
			if not arrow:
				arrow= Bladex.CreateEntity(arrow_name,self.ArrowType,0,0,0,"Arrow")
			#if arrow.Scale>1.1: print "Arrow has been rescaled!!!"
			flying= arrow.Velocity!=(0.0, 0.0, 0.0)
			if (allow_parented or not arrow.Parent) and (allow_flying or not flying):
				if arrow.Parent:
					parent= Bladex.GetEntity(arrow.Parent)
					if parent: parent.Unlink(arrow)
					#if arrow.Scale>1.1: print "Arrow has been rescaled!!!"

				arrow.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				arrow.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				if flying:
					arrow.Stop()
					#if arrow.Scale>1.1: print "Arrow has been rescaled!!!"
				arrow.Position=0,0,0
				self.ArrowCache.remove(arrow_name)
				self.ArrowCache.append(arrow_name)
				return arrow
		
		if not allow_parented:
			return self.GetFirstArrow(1)
		else:
			# Returning flying arrows has some strange visual side effects
			return self.GetFirstArrow(1, 1)
	
	def GiveArrow (self, owner_name=""):
		if self.ArrowsLeft > 0:
			arrow= self.GetFirstArrow()
			# debug
			if arrow.Parent:
				print "GiveArrow giving arrow with parent"
				#pdb.set_trace()
			if not owner_name:
				me= Bladex.GetEntity(self.Name)
				owner_name= me.Parent
			if owner_name:
				owner=Bladex.GetEntity(owner_name)
				
				if owner and owner.Person: 
					lvl=owner.Level+1 
					if lvl<18:
						lvlfactor=lvl*50
					else:
						lvlfactor=1000
					bow=Bladex.GetEntity(owner.InvLeft)
					if bow.Kind=="Arco3":   #Medium
						bowfactor=2
					elif bow.Kind=="Arco2": #Heavy
						bowfactor=3
					elif bow.Kind=="Arco": #Light
						bowfactor=1
					else:
						bowfactor=1
					dam=lvlfactor*bowfactor
					firedam=lvlfactor  
					if not Reference.EntitiesObjectData.has_key(arrow.Name):
						Reference.EntitiesObjectData[arrow.Name]= BCopy.deepcopy(Reference.DefaultObjectData[arrow.Kind])
						Reference.EntitiesObjectData[arrow.Name][1]= dam
						if arrow.Kind=="FlechaEnvenenada":
							Reference.EntitiesObjectData[arrow.Name].append(['Venom', +lvl])
						if arrow.Kind=="FlechaFuego":
							Reference.EntitiesObjectData[arrow.Name].append(['Fire', +firedam])
					print"Arrow damge set at"
					print dam
					if owner.Name=="Player1":
					#if not owner.Data.NPC:
						self.SetNumberOfArrows (self.ArrowsLeft-1)
					
			else:
				print "Arrow given from quiver with no parent"
				#pdb.set_trace()
			self.ArrowsUsed= self.ArrowsUsed+1
			arrow.CastShadows= 1
			return arrow
	
	def ReceiveArrow (self, entity, owner_name=""):
		if entity and entity.Arrow and entity.Kind==self.ArrowType:
			if not owner_name:
				me= Bladex.GetEntity(self.Name)	
				owner_name= me.Parent
			if owner_name:
				owner=Bladex.GetEntity(owner_name)
				if owner and owner.Person and owner.Data:
					if Reference.EntitiesObjectData.has_key(entity):
						del Reference.EntitiesObjectData[entity]
					#if not owner.Data.NPC:
					if owner.Name=="Player1":
						if self.ArrowsLeft < self.MaxArrows:
							self.SetNumberOfArrows (self.ArrowsLeft+1,owner_name)
						else:
							return 0
			else:
				print "Arrow received to quiver with no parent"
				#pdb.set_trace()
			entity.SubscribeToList("Pin")
			return 1
		return 0

	def ReceiveArrows (self, num_arrows, owner_name=""):
		if not owner_name:
			me= Bladex.GetEntity(self.Name)
			owner_name= me.Parent
		if owner_name:
			owner=Bladex.GetEntity(owner_name)
			if owner and owner.Person and owner.Data:
				#if not owner.Data.NPC:
				if owner.Name=="Player1":
					self.SetNumberOfArrows (min (self.ArrowsLeft+num_arrows, self.MaxArrows),owner_name)
		
	
	def NumberOfArrows (self):
		return self.ArrowsLeft
	
	def SetNewBOD(self, old_quiver, kind,holder_name=""):
		x,y,z= old_quiver.Position
		
		###########################################################
		# Destroy the old object
		#
		# Are we being held
		holder= None
		put_on_back= 0
		inv= None
		if not holder_name:
			holder_name= old_quiver.Parent
		selected_quiver=""
		if holder_name:
			holder= Bladex.GetEntity(holder_name)
		
			# Remove from back..., deselect, remove from inventory
			if holder:
				inv= holder.GetInventory()
				selected_quiver= inv.GetSelectedQuiver()
				if self.Name==holder.InvRightBack:
					put_on_back= 1
					inv.LinkRightBack("None")
				inv.RemoveQuiver(old_quiver.Name)
		else: print "WARNING:  changing quiver BOD with no detected holder!!!!"
		
		# delete the old object
		data= old_quiver.Data
		old_quiver.RemoveFromWorld()
		Bladex.DeleteEntity(old_quiver.Name)
		
		###########################################################
		#
		# Create the new object
		new_quiver= Bladex.CreateEntity(self.Name,kind,x,y,z,"Physic")
		new_quiver.Data= data
		self.Name= new_quiver.Name
		
		# Add the holders inventory, select, and link to back
		if holder:
			inv.AddQuiver(new_quiver.Name)
			if selected_quiver:
				while inv.GetSelectedQuiver()!=selected_quiver:
					inv.CycleQuivers()
			inv.SetCurrentQuiver(new_quiver.Name)
			if put_on_back:
				inv.LinkRightBack(new_quiver.Name)
				inv.SetCurrentQuiver(new_quiver.Name)
			else:
				# Hide in inventory
				new_quiver.RemoveFromWorld()
				
	def SetNumberOfArrows(self, num, owner_name=""):
		#import pdb
		#pdb.set_trace()
		if num<1:
			# Change to the empty quiver, if we are not using it
			old_quiver= Bladex.GetEntity(self.Name)
			newkind= self.BaseKind+'_E'
			if newkind!=old_quiver.Kind:	# Check we don't already have the empty carcaj model?
				self.SetNewBOD(old_quiver,newkind,owner_name)
		elif num==1:
			# Change to the 1 arrow quiver
			old_quiver= Bladex.GetEntity(self.Name)
			newkind= self.BaseKind+'1'
			if newkind!=old_quiver.Kind:	# Check we don't already have the 1 arrow carcaj model?
				self.SetNewBOD(old_quiver,newkind,owner_name)
		elif num==2:
			# Change to the 2 arrow quiver
			old_quiver= Bladex.GetEntity(self.Name)
			newkind= self.BaseKind+'2'
			if newkind!=old_quiver.Kind:	# Check we don't already have the 1 arrow carcaj model?
				self.SetNewBOD(old_quiver,newkind,owner_name)
		else:
			# Change to the full quiver
			old_quiver= Bladex.GetEntity(self.Name)
			newkind= self.BaseKind
			if newkind!=old_quiver.Kind:	# Check we don't already have the 1 arrow carcaj model?
				self.SetNewBOD(old_quiver,newkind,owner_name)
		
		self.ArrowsLeft=num
		


class CarcajFuego (Quiver):
	def GiveArrow (self, owner_name=""):
		entity=Quiver.GiveArrow(self, owner_name)
		if entity:
			# Switch on flame effect
			entity.FiresIntensity=[ 0 ]
			entity.Lights=[ (1.000000,0.500000,(255,128,0)) ]
			entity.CastShadows= 0
			lite=AuxFuncs.GetSpot(entity)
			lite.CastShadows=0
		return entity
		
	def ReceiveArrow (self, entity, owner_name=""):
		if entity and entity.Arrow and entity.Kind==self.ArrowType:
			# Switch off flame effect
			entity.Lights=[ (0.000000,0.500000,(255,196,128)) ]
		return Quiver.ReceiveArrow(self, entity, owner_name)


class Carcaj (Quiver):
	pass

class Carcaj_E (Carcaj):
	pass

class Carcaj1 (Carcaj):
	pass

class Carcaj2 (Carcaj):
	pass


class CarcajFuego_E (CarcajFuego):
	pass

class CarcajFuego1 (CarcajFuego):
	pass

class CarcajFuego2 (CarcajFuego):
	pass

class CarcajEnvenenado (Quiver):
	pass

class CarcajEnvenenado_E (CarcajEnvenenado):
	pass

class CarcajEnvenenado1 (CarcajEnvenenado):
	pass

class CarcajEnvenenado2 (CarcajEnvenenado):
	pass
	
	
classes_defined= dir()
def QuiverTypeFuncs (item):
	class_found=0
	if item.Kind in classes_defined:	
		exec_string = 'item.Data=' + item.Kind + '(item)'
		exec (exec_string)
		if not item.Data:
			raise NameError, 'Kind must have valid associated class'
			class_found=0
		else:
			class_found=1
		Bladex.CheckPyErrors()
		
	
	if not class_found:
		InitDataField.Initialise(item)
